% programma ottimo SOC
clear
clc

%(8.5) riga 27
%(3.4) colonna 4

rho_aria =1.225;
Cd =0.28;
S_ev =2.19;
f_volv =0.0083;
m_v =1645;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
g =9.81;
phi_i =0;
delta =1.05;
rt =0.315;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%

T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s
i_0tr= 1; %valore del riduttore
T_em_maxspeed =76.3944;

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

% costante1_x =((2*pi)/60)*3.6*(rt/marcia.prima);
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);

SOC =0.9; %valore iniziale della batteria
delta_t =1; %intervallo in cui studio la variazione della batteria [sec]
Ud_k =300; %tensione batteria [V]
acceleraz_max =2.8571; %accelerazione massima raggiunta durante la prova NEDC
C_batt= 70; %capacità batteria espressa in Ampere ora [A h]

i_1 =struct('min',5.9, 'max',19.6);
i_2 =struct('min',1.8, 'max',5.7);




% F_aerodinamica_i =0.5*rho_aria*Cd*S_ev*((v/3.6)^2);
%F_aerodinamica_i =(0.5*rho_aria*Cd*S_ev*((vel_veicolo(t)/3.6)^2));
% F_attrito_i =f_volv*m_v_1*g*cosd(phi_i);
% F_climbing_i =m_v_1*g*sind(phi_i);
% F_accelerazione =((v-v_precedente)>0)*(m_v*delta*((v-v_precedente)/3.6));
%F_accelerazione =(((vel_veicolo(t)-vel_veicolo(t-1))>0)*(m_v*delta*((vel_veicolo(t)-vel_veicolo(t-1))/3.6)));

% F_req_k =F_aerodinamica_i+F_attrito_i+F_climbing_i+F_accelerazione;
% Tw_req_k =F_req_k*rt; %[Nm]

% v=120;
% v_precedente=120;
% F_aerodinamica_i =0.5*rho_aria*Cd*S_ev*((v/3.6)^2);
F_attrito_i =f_volv*m_v_1*g*cosd(phi_i);
F_climbing_i =m_v_1*g*sind(phi_i);
% F_accelerazione =((v-v_precedente)>0)*(m_v*delta*((v-v_precedente)/3.6));

            

vel_istanti =zeros(1,1179);
for i=1:1179

    vel_istanti(1,i) =vel_veicolo(i);

end
            
                       
Tw_req_k_vett =  ((0.5*rho_aria*Cd*S_ev*((vel_istanti(1,2:end)./3.6).^2))+F_attrito_i+F_climbing_i+...
                 (((vel_istanti(1,2:end)-vel_istanti(1,1:end-1))>0).*(m_v*delta*((vel_istanti(1,2:end)-vel_istanti(1,1:end-1))/3.6))))*rt; 

            
 

% eta_1 =P_em_i/(P_em_i+P_loss_i);
% eta_2 =P_em_i/(P_em_i+P_loss_i);
% 
% P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i;
% Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
% Tw_req_mot_kmh2 =Tw_req_50/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento
% vel_Tem_cambio_km_1 =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
% vel_Tem_cambio_km_2 =(vel_Tem_cambio(i)/costante2_x)*(pi/30);
% costante1_x =(((2*pi)/60)*3.6*(rt/marcia.prima));
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);
% 
% parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
% parte_2 =kc*(coppia_mev_marcia1.uno^2)*(T_ref/T_em)^2;
% parte_3 =ki*vel_Tem_cambio_km_i*(n_ref/n_mot_rad_s);
% parte_4 =kw*(vel_Tem_cambio_km_i^3)*(n_ref/n_mot_rad_s)^3;
% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C);            



% P_em_i =        ((Tw_req_k(t)./(T_em*x(1)))*T_em)*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30));



parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
% parte_2 =kc*(((Tw_req_k(t)./(T_em*x(1)))*T_em).^2)*(T_ref/T_em)^2;
% parte_3 =ki*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30))*(n_ref/n_mot_rad_s);
% parte_4 =kw*(((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30)).^3)*(n_ref/n_mot_rad_s)^3;
% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]


% P_loss_i =        parte_1*((kc*(((Tw_req_k(t)./(T_em*x(1)))*T_em).^2)*(T_ref/T_em)^2)+...
%                   (ki*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30))*(n_ref/n_mot_rad_s))+...
%                   (kw*(((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30)).^3)*(n_ref/n_mot_rad_s)^3)+C);

              
              
P_em_i_1_vett =@(x) (Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_1_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);
 
fun_eta_1_vett =@(x) ((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));
 

P_em_i_2_vett =@(x) (Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_2_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_2_vett =@(x) ((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));                 
                 
   
                 
% eta_max =@(t,x) max((fun_eta_1(t,x)),(fun_eta_2(t,x)));


fun_eta_1_meno_2_vett =@(x) (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))))-...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
                       

scelta_marcia_vett =@(x) (fun_eta_1_meno_2_vett(x)>=0)*x(1) + (fun_eta_1_meno_2_vett(x)<0)*x(2);   

                     
                     
% P_m_k =(T_m_k*omega_m_k)/(9550*eta_i_k);

% T_m_k =((Tw_req_k(t))./(scelta_marcia(t,x)*i_0tr*eta_pt));
% Tw_req_k_1 =(Tw_req_k(t)./(T_em*x(1)))*T_em;
% T_m_k =((Tw_req_k(t)./(T_em*(scelta_marcia(t,x))))*T_em)./(scelta_marcia(t,x)*i_0tr*eta_pt);
% T_m_k =Tw_req_k/(marcia_i*i_0tr*eta_pt);
% Tw_req_k =F_req_k*rt;
            
% omega_m_k =(30*marcia_i*i_0tr*(v/3.6))/(pi*rt);
% omega_m_k =(30*i_0tr*scelta_marcia(t,x).*(vel_veicolo(t)/3.6))/(pi*rt);
% omega_m_k_rads =omega_m_k*(pi/30);
% omega_m_k_rads =((30*i_0tr*scelta_marcia(t,x).*(vel_veicolo(t)/3.6))/(pi*rt))*(pi/30);
% eta_i_k =P_em_i/(P_em_i+P_loss_i);

                
P_gen_vett =@(x) (Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x).*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));
 
P_loss_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_vett =@(x) ((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                   (((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                   (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));
 

                
% fun_eta_i_k(550,([8.5,3.4])                
% +(vel_veicolo(t) == 0)



% P_m_k =(T_m_k*omega_m_k)/(9550*eta_i_k)
%((fun_eta_vett(x) == 0)+fun_eta_vett(x))
              
              
fun_P_m_k_vett =@(x) ((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./...
                     (9550*((fun_eta_vett(x) == 0)+fun_eta_vett(x)));

                 
% ((fun_eta_i_k(t,x) == 0)+fun_eta_i_k(t,x)) %per evitare di avere al denominatore uno zero nel caso di v=0;            


% Id_k =P_m_k*1000/Ud_k; %ampere
fun_Id_k_vett =@(x) fun_P_m_k_vett(x).*1000/Ud_k; %ampere

 
% delta_SOC =(Id_k/(3600*C_batt))*delta_t;
fun_SOC_spesa_vett =@(x) ((fun_P_m_k_vett(x).*1000/Ud_k)./(3600*C_batt))*delta_t;

% SOC =SOC-delta_SOC;  
fun_obiettivo =@(x) sum(fun_SOC_spesa_vett(x));




x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[i_1.min,i_2.min];
ub =[i_1.max,i_2.max];

nonlincon =@nlcon;

marce_SOC_migliore =fmincon(fun_obiettivo,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
SOC_residuo = SOC-fun_obiettivo([marce_SOC_migliore(1),marce_SOC_migliore(2)]);
fprintf('\nla combinazione di ingranaggi che ottimizza il valore SOC è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_SOC_migliore(1),marce_SOC_migliore(2)) 
fprintf('\nil valore SOC è: %.4f\n',SOC_residuo) 



