% Programma ottimo generale, Vel_0_100 + SOC

% clear
% clc

%inserimento dati (FISSI)
m_v =1645;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
delta =1.05;
v_climb =15;
rt =0.315;
f_volv =0.0083;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%
g =9.81;
rho_aria =1.225;
phi_50 =0;
phi_i =0;
Cd =0.28;

T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
S_ev =2.19;
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s
i_0tr= 1; %valore del riduttore
T_em_maxspeed =76.3944;

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);

SOC =0.9; %valore iniziale della batteria
delta_t =1; %intervallo in cui studio la variazione della batteria [sec]
Ud_k =300; %tensione batteria [V]
acceleraz_max =2.8571; %accelerazione massima raggiunta durante la prova NEDC
C_batt= 70; %capacità batteria espressa in Ampere ora [A h]

%parte fissa del ragionamento, infatti la coppia resistente è sempre la stessa
%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata

F_attrito_i =f_volv*m_v_1*g*cosd(phi_i);
F_climbing_i =m_v_1*g*sind(phi_i);

i_1 =struct('min',5.9, 'max',19.6);
i_2 =struct('min',1.8, 'max',5.7);

%estremi integrazione fissi
a_1=0;
d_4=27.8;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parte SOC

vel_istanti =zeros(1,1179);
for i=1:1179

    vel_istanti(1,i) =vel_veicolo(i);

end
            
                       
Tw_req_k_vett =  ((0.5*rho_aria*Cd*S_ev*((vel_istanti(1,2:end)./3.6).^2))+F_attrito_i+F_climbing_i+...
                 (((vel_istanti(1,2:end)-vel_istanti(1,1:end-1))>0).*(m_v*delta*((vel_istanti(1,2:end)-vel_istanti(1,1:end-1))/3.6))))*rt; 



P_em_i_1_vett =@(x) (Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_1_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);
 
fun_eta_1_vett =@(x) ((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));
 

P_em_i_2_vett =@(x) (Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_2_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_2_vett =@(x) ((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))); 

                 
                 
fun_eta_1_meno_2_vett =@(x) (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))))-...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));

scelta_marcia_vett =@(x) (fun_eta_1_meno_2_vett(x)>=0)*x(1) + (fun_eta_1_meno_2_vett(x)<0)*x(2); 



P_gen_vett =@(x) (Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x).*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));
 
P_loss_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_vett =@(x) ((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                   (((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                   (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));

               
              
fun_P_m_k_vett =@(x) ((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./...
                     (9550*((fun_eta_vett(x) == 0)+fun_eta_vett(x)));

% Id_k =P_m_k*1000/Ud_k; %ampere
fun_Id_k_vett =@(x) fun_P_m_k_vett(x).*1000/Ud_k; %ampere

% delta_SOC =(Id_k/(3600*C_batt))*delta_t;
fun_SOC_spesa_vett =@(x) ((fun_P_m_k_vett(x).*1000/Ud_k)./(3600*C_batt))*delta_t;

% SOC =SOC-delta_SOC;  
fun_obiettivo =@(x) sum(fun_SOC_spesa_vett(x));



x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[i_1.min,i_2.min];
ub =[i_1.max,i_2.max];

nonlincon =@nlcon;

marce_SOC_migliore =fmincon(fun_obiettivo,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
SOC_residuo = SOC-fun_obiettivo([marce_SOC_migliore(1),marce_SOC_migliore(2)]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Parte v_0_100

fun_intersez_1_inc =@(z,x) ((((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(1).*i_0tr)))./...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(1).*i_0tr)))+...
                           (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x(1).*i_0tr)).^2).*(T_ref/T_em)^2)+...
                           (ki.*((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                           (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(2).*i_0tr)))./...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(2).*i_0tr)))+...
                           (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x(2).*i_0tr)).^2).*(T_ref/T_em)^2)+...
                           (ki.*((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                           (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));

fun_int_1 = @(z,x) (m_v*delta)./((((T_em*x(1))*v_climb*3.6)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));
fun_int_2 = @(z,x) (m_v*delta)./(((T_em_maxspeed*x(2)*v_max*3.6)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));

            
int_finale =@(x) integral(@(z) fun_int_1(z,x),0,(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)))... 
                +integral(@(z) fun_int_2(z,x),(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)),27.8) +2; 
            
            
            
x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[i_1.min,i_2.min];
ub =[i_1.max,i_2.max];

nonlincon =@nlcon;

marce_0_100_migliore =fmincon(int_finale,x0,A,B,Aeq,Beq,lb,ub,nonlincon);

Vel_marce_scelte =int_finale([marce_0_100_migliore(1),marce_0_100_migliore(2)]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%mi trovo il valore max del SOC
fun_obiettivo_max =@(x) SOC-sum(fun_SOC_spesa_vett(x));

marce_SOC_migliore_max =fmincon(fun_obiettivo_max,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
SOC_residuo_max = fun_obiettivo_max([marce_SOC_migliore_max(1),marce_SOC_migliore_max(2)]);


%mi trovo il valore max del metodo 0_100_km
int_finale_max=@(x) -(integral(@(z) fun_int_1(z,x),0,(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)))... 
                    +integral(@(z) fun_int_2(z,x),(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)),27.8) +2); 
            
marce_0_100_migliore_max =fmincon(int_finale_max,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
Vel_marce_scelte_max =-(int_finale_max([marce_0_100_migliore_max(1),marce_0_100_migliore_max(2)]));            


fprintf('\nil valore SOC residuo min è pari a: %.4f\n',SOC_residuo_max) 
fprintf('il valore della velocità max per portare il veicolo da 0-100 km/h è pari a: %.4f\n',Vel_marce_scelte_max)

fprintf('\nla combinazione di ingranaggi che ottimizza il valore SOC è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_SOC_migliore(1),marce_SOC_migliore(2)) 
fprintf('\nil valore SOC residuo max è pari a: %.4f\n',SOC_residuo) 

fprintf('\nla combinazione di ingranaggi che mi ottimizza il tempo da 0-100 è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_0_100_migliore(1),marce_0_100_migliore(2)) 
fprintf('\nil tempo minimo impegato per portare il veicolo da 0-100 km/h è pari a: %.2f secondi\n',Vel_marce_scelte) 


%mi calcolo le funzioni obiettivo da ottimizzare
peso_SOC =0.7;
peso_0_100 =1-peso_SOC;

funz_normaliz_0_100 =@(x) (Vel_marce_scelte_max-int_finale(x))./(Vel_marce_scelte_max-Vel_marce_scelte);
funz_normaliz_SOC =@(x) (fun_obiettivo_max(x)-SOC_residuo_max)./(SOC_residuo-SOC_residuo_max);

funz_globale_obiettivo =@(x) -(peso_SOC.*funz_normaliz_SOC(x) +peso_0_100.*funz_normaliz_0_100(x));

marce_globali_migliori =fmincon(funz_globale_obiettivo,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
valore_marce_globali =-(funz_globale_obiettivo([marce_globali_migliori(1),marce_globali_migliori(2)]));

fprintf('\nil valore ponderato della coppia migliore di ingranggi è: %.4f\n',valore_marce_globali) 
fprintf('\nla combinazione di ingranaggi che ottimizza Globalmente è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_globali_migliori(1),marce_globali_migliori(2)) 


