%% prova creazione di una funzione per il calcolo vel 0-100
clear
clc

%inserimento dati (FISSI)
m_v =1645;
delta =1.05;
v_climb =15;
rt =0.315;
f_volv =0.0083;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%
g =9.81;
rho_aria =1.225;
phi_50 =0;
Cd =0.28;
T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
S_ev =2.19;
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
i_0tr= 1; %valore del riduttore
T_em_maxspeed =76.3944;

i_1 =struct('min',5.9, 'max',19.6);
i_2 =struct('min',1.8, 'max',5.7);


%parte fissa del ragionamento, infatti la coppia resistente è sempre la stessa
%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata

n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);

%estremi integrazione fissi
a_1=0;
d_4=27.8;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% (fine parte dati FISSI)


%%provo a sviluppare la parte di ottimizzazione

%com'è stata trovata la funzione intersez:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% vel_intersez =round(fsolve(@(z) fun_intersez_1_inc(z,x),10));
% fun_intersez =eta_1-eta_2;
% 
% eta_1 =P_em_i/(P_em_i+P_loss_i);
% eta_2 =P_em_i/(P_em_i+P_loss_i);
% 
% P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i;
% Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
% Tw_req_mot_kmh2 =Tw_req_50/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento
% vel_Tem_cambio_km_1 =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
% vel_Tem_cambio_km_2 =(vel_Tem_cambio(i)/costante2_x)*(pi/30);
% costante1_x =(((2*pi)/60)*3.6*(rt/marcia.prima));
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);
% 
% parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
% parte_2 =kc*(coppia_mev_marcia1.uno^2)*(T_ref/T_em)^2;
% parte_3 =ki*vel_Tem_cambio_km_i*(n_ref/n_mot_rad_s);
% parte_4 =kw*(vel_Tem_cambio_km_i^3)*(n_ref/n_mot_rad_s)^3;
% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


fun_intersez_1_inc =@(z,x) ((((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(1).*i_0tr)))./...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(1).*i_0tr)))+...
                           (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x(1).*i_0tr)).^2).*(T_ref/T_em)^2)+...
                           (ki.*((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                           (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x(1)))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(2).*i_0tr)))./...
                           ((((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(Tw_req_50./(eta_pt.*x(2).*i_0tr)))+...
                           (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x(2).*i_0tr)).^2).*(T_ref/T_em)^2)+...
                           (ki.*((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                           (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x(2)))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));

fun_int_1 = @(z,x) (m_v*delta)./((((T_em*x(1))*v_climb*3.6)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));
fun_int_2 = @(z,x) (m_v*delta)./(((T_em_maxspeed*x(2)*v_max*3.6)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));

            
int_finale =@(x) integral(@(z) fun_int_1(z,x),0,(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)))... 
                +integral(@(z) fun_int_2(z,x),(round(fsolve(@(z) fun_intersez_1_inc(z,x),10)/3.6)),27.8) +2;            

% x=8.5; %[marcia_1]
% y=3.4; %[marcia_2]  
%[8.5,3.4],[16.8,5.25]
% risposta =int_finale([8.5,3.4]);
% vel_cambio_int =fsolve(@(z) fun_intersez_1_inc(z,[8.5,3.4]),10);           
%             
% fprintf('\nil tempo impiegato per andare da 0-100 è di %.2f secondi (con v cambio = %.2f)\n',risposta,vel_cambio_int)   


x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[5.9,1.8];
ub =[19.6,5.7];

nonlincon =@nlcon;

marce_0_100_migliore =fmincon(int_finale,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
fprintf('\nla combinazione di ingranaggi che mi ottimizza il tempo da 0-100 è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_0_100_migliore(1),marce_0_100_migliore(2)) 

Vel_marce_scelte =int_finale([marce_0_100_migliore(1),marce_0_100_migliore(2)]);
fprintf('\nil tempo minimo impegato per portare il veicolo da 0-100 km/h è pari a: %.2f secondi\n',Vel_marce_scelte) 
