% programma per la ricerca punti di intersezione tra rette

F1 =@(x) x^2-2;
F2 =@(x) 3*x-1;
% fplot(F1,[-2 4]); 
% hold on 
% fplot(F2,[-2 4]);

fun =@(x) (x^2-2)-(3*x-1);
X_int =fsolve(fun,3);
Y_int =3*X_int-1;

fprintf('X uguale a: %f\nY uguale a: %f', X_int,Y_int);


%% sopra ho trovato la funzione di intersezione generica, devo applicarla al mio caso


% F1 =@(x) x^2-2;

f_eta_1 =P_em_i/(P_em_i+P_loss_i);


P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i;

        vel_Tem_cambio_km_i =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
        Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento



         
         
         
         
%% prova creazione di una funzione integrale

%inserimento dati (FISSI)
m_v =1645;
delta =1.05;
v_climb =15;
rt =0.315;
f_volv =0.0083;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%
g =9.81;
rho_aria =1.225;
phi_50 =0;
Cd =0.28;
T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
S_ev =2.19;
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
i_0tr= 1; %valore del riduttore
T_em_maxspeed =76.3944;



%parte fissa del ragionamento, infatti la coppia resistente è sempre la stessa
%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata

n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% (fine parte dati FISSI)
%%

%inserimento dati (VARIABILI)
% marcia.seconda =3.4; %%%(varia in un range)
% marcia.prima =8.5; %%%(varia in un range)
% T_em_marcia1 =T_em*marcia.prima; %%%(moltiplicazione per un range)
% vel_cambio_kmh_pp =20.1637; %%% PROBLEMATICO!

%%%%%%%%% DEVO TORVARE IL PUNTO DI INTERSEZIONE TRA LE DUE CURVE




% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C);
         
%          parte_2 =kc*(y^2)*(T_ref/T_em)^2;
%          parte_3 =ki*x*(n_ref/n_mot_rad_s);
%          parte_4 =kw*(x^3)*(n_ref/n_mot_rad_s)^3;
         
%          parte_2 =kc*(y.^2).*(T_ref/T_em)^2;
%          parte_3 =ki.*x.*(n_ref/n_mot_rad_s);
%          parte_4 =kw.*(x.^3).*(n_ref/n_mot_rad_s)^3;

%(funzione che ha in entrata: X=vel_Tem_cambio_km_i, Y=Tw_req_mot_kmh1)
fun_p_loss_1 =@(x,y) parte_1.*((kc.*(y.^2).*(T_ref/T_em)^2)+(ki.*x.*(n_ref/n_mot_rad_s))+(kw.*(x.^3).*(n_ref/n_mot_rad_s)^3)+C);

a =841.0053; %[X =vel_Tem_cambio_km_i] [rad/s]
b =14.2499; %[Y =Tw_req_mot_kmh2] [Nm]

c =52.4691; %[X =vel_Tem_cambio_km_i] [rad/s]
d =5.7; %[Y =Tw_req_mot_kmh1] [Nm]



% P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i;
% 
%         vel_Tem_cambio_km_i =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
%         Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento

%(funzione che ha in entrata: X=vel_Tem_cambio_km_i, Y=Tw_req_mot_kmh1)
fun_pot_1 =@(x,y) x*y;


% f_eta_1 =P_em_i/(P_em_i+P_loss_i);

%(funzione che ha in entrata: X=vel_Tem_cambio_km_i, Y=Tw_req_mot_kmh1)
fun_eta_1 =@(x,y) (x.*y)./((x.*y)+(parte_1.*((kc.*(y.^2).*(T_ref/T_em)^2)+(ki.*x.*(n_ref/n_mot_rad_s))+(kw.*(x.^3).*(n_ref/n_mot_rad_s)^3)+C)));



risposta_pLoss =fun_p_loss(a,b);
risposta_pot =fun_pot(a,b);

risposta_eta_1 =fun_eta(a,b);
risposta_eta_2 =fun_eta(c,d);

disp(['risposta loss = ' num2str(risposta_pLoss)]);
disp(['risposta pot = ' num2str(risposta_pot)]);
disp(['risposta eta 1 = ' num2str(risposta_eta_1)]);
disp(['risposta eta 2 = ' num2str(risposta_eta_2)]);


%%
%questo funziona inserendo la T e la velocita manualmente. devo fare in modo che sia scritto inserendo le marce:
% costante1_x =(((2*pi)/60)*3.6*(rt/marcia.prima));
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);


%: vel_Tem_cambio_km_i
% v_max_marcia1 =n_mot*costante1_x;
% v_max_marcia2 =n_mot*costante2_x;
% v_max_marce_max =max(v_max_marcia1,v_max_marcia2);
% vel_Tem_cambio =(0:h:v_max_marce_max);
% 
% vel_Tem_cambio_km_i =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
% 
% costante1_x =((((2*pi)/60)*3.6).*(rt./y));

% vel_Tem_cambio_km_i =((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30));


%: Tw_req_mot_kmh1)
% Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
% Tw_req_mot_kmh2 =Tw_req_50/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento


%provo a scrivere tutto in funzione dei rapporti di trasmissione (scrivo Tw_req_mot_kmh1 in funzione solo di marcia.1)
% Tw_req_mot_kmh1 =(Tw_req_50./(eta_pt.*x.*i_0tr));
% Tw_req_mot_kmh1 =(Tw_req_50./(eta_pt.*y.*i_0tr));
%vel_Tem_cambio_km_i =((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30));
%vel_Tem_cambio_km_i =((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30));


% Funzione eta_1: (z: velocità in km/h, y: marcia_1)
fun_eta_1 =@(z,x) (((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));    



% Funzione eta_2: (z: velocità in km/h, x: marcia_2)
fun_eta_2 =@(z,y) (((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));

              
a =40; %[Z =velocità] [kmh]
b =8.5; %[X =marcia_1]
c =3.4; %[Y =marcia_2]

risposta_eta_1 =fun_eta_1(a,b);
disp(['risposta eta 1 = ' num2str(risposta_eta_1)]);

risposta_eta_2 =fun_eta_2(a,c);
disp(['risposta eta 2 = ' num2str(risposta_eta_2)]);


fun_intersez =@(z,x,y) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                       ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                       (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                       (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                       (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))))-...
                       ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                       ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                       (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                       (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                       (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));

                   
risposta_fun_int =fun_intersez(a,b,c);
disp(['risposta legge cambio = ' num2str(risposta_fun_int)]);
%con tre incognite non risco a far funzionare fsolve.....con una si


%RISOLUZIONE DEL PROBLEMA CON INCOGNITA SOLO LA VELOCITA'
x=8.5; %[marcia_1]
y=3.4; %[marcia_2]

fun_eta_1_1var =@(z) (((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));  
              
fun_eta_2_2var =@(z) (((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));

fun_intersez_1_inc =@(z) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                         ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                         (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                         (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                         (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                         ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                         ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                         (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                         (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                         (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
               
               
X_int =fsolve(fun_intersez_1_inc,10);
Y_int =fun_eta_1_1var(X_int);

fprintf('X uguale a: %f\nY uguale a: %f', X_int,Y_int);            


%%

fun_intersez_1_inc =@(z,x,y) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
                      
                     
punto_inters =@(x,y) fsolve(@(z) fun_intersez_1_inc(z,x,y),10);                   
                     
risposta =punto_inters(8.5,3.4);

fprintf('\nil tempo impiegato per andare da 0-100 è di %.2f secondi',risposta)           


