%% prova creazione di una funzione per il calcolo vel 0-100
clear
clc

%inserimento dati (FISSI)
m_v =1645;
delta =1.05;
v_climb =15;
rt =0.315;
f_volv =0.0083;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%
g =9.81;
rho_aria =1.225;
phi_50 =0;
Cd =0.28;
T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
S_ev =2.19;
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
i_0tr= 1; %valore del riduttore
T_em_maxspeed =76.3944;


%parte fissa del ragionamento, infatti la coppia resistente è sempre la stessa
%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata

n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);

%estremi integrazione fissi
a_1=0;
d_4=27.8;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% (fine parte dati FISSI)


%%
%RISOLUZIONE DEL PROBLEMA CON INCOGNITA SOLO LA VELOCITA' (vario le marce)
x=8.5; %[marcia_1]
y=3.4; %[marcia_2]

fun_eta_1_1var =@(z) (((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));  
              
fun_eta_2_2var =@(z) (((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                  ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                  (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                  (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                  (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));

fun_intersez_1_inc =@(z) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                         ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                         (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                         (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                         (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                         ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                         ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                         (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                         (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                         (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
               
               
b_2 =fsolve(fun_intersez_1_inc,10);
% intermezzo =round(b_2/3.6);
rend_b_2 =fun_eta_1_1var(b_2);

fprintf('X uguale a: %f\nY uguale a: %f', b_2,rend_b_2);

%funzione integrale che funziona
% fun_int_1 = @(z) (m_v*delta)./(  (((T_em*x)*v_climb)./(rt*3.6.*z)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*z).^(2)) )  );
% fun_int_2 = @(z) (m_v*delta)./(  ((T_em_maxspeed*y*v_max)./(rt*3.6.*z)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*z).^(2)) )  );

% fun_int_1 = @(z) ((m_v*delta)./((((T_em*x)*v_climb)./(rt*3.6.*z))-F_attrito_50-(((Cd*S_ev)/(21.15))*((3.6.*z).^(2)))));
% fun_int_2 = @(z) ((m_v*delta)./(((T_em_maxspeed*y*v_max)./(rt*3.6.*z))-F_attrito_50-(((Cd*S_ev)/(21.15))*((3.6.*z).^(2)))));

%funzioni che funzionano
% int_finale =@(k) integral(fun_int_1,0,k) +integral(fun_int_2,k,27.8) +2;
% int_finale =@(j) integral(fun_int_1,0,(round(fsolve(fun_intersez_1_inc,10)/3.6))) +integral(fun_int_2,(round(fsolve(fun_intersez_1_inc,10)/3.6)),27.8) +2;


fun_int_1 = @(z,x) (m_v*delta)./((((T_em*x)*v_climb)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));
fun_int_2 = @(z,y) (m_v*delta)./(((T_em_maxspeed*y*v_max)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));

int_finale =@(x,y) integral(@(z) fun_int_1(z,x),0,(round(fsolve(fun_intersez_1_inc,10)/3.6)))... 
                  +integral(@(z) fun_int_2(z,y),(round(fsolve(fun_intersez_1_inc,10)/3.6)),27.8) +2;


risposta =int_finale(8.5,3.4);

fprintf('\nil tempo impiegato per andare da 0-100 è di %.2f secondi',risposta)


% x=8.5; %[marcia_1]
% y=3.4; %[marcia_2]


%%

fun_intersez_1_inc =@(z,x,y) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
                         
fun_int_1 = @(z,x) (m_v*delta)./((((T_em*x)*v_climb)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));
fun_int_2 = @(z,y) (m_v*delta)./(((T_em_maxspeed*y*v_max)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));


int_finale =@(x,y) integral(@(z) fun_int_1(z,x),0,(round(fsolve(@(z) fun_intersez_1_inc(z,x,y),10)/3.6)))... 
                  +integral(@(z) fun_int_2(z,y),(round(fsolve(@(z) fun_intersez_1_inc(z,x,y),10)/3.6)),27.8) +2;

             
risposta =int_finale(16.8,5.25);
vel_cambio_int =fsolve(@(z) fun_intersez_1_inc(z,16.8,5.25),10);

fprintf('\nil tempo impiegato per andare da 0-100 è di %.2f secondi (con v cambio = %.2f)\n',risposta,vel_cambio_int)                         
                         
                         
%% provo a sviluppare la parte di ottimizzazione


fun_intersez_1_inc =@(z,x,y) ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(Tw_req_50./(eta_pt.*x.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*x.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./x))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)))) -...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))./...
                             ((((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(Tw_req_50./(eta_pt.*y.*i_0tr)))+...
                             (parte_1.*((kc.*((Tw_req_50./(eta_pt.*y.*i_0tr)).^2).*(T_ref/T_em)^2)+...
                             (ki.*((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).*(n_ref/n_mot_rad_s))+...
                             (kw.*(((z./((((2*pi)/60)*3.6).*(rt./y))).*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));

fun_int_1 = @(z,x) (m_v*delta)./((((T_em*x)*v_climb)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));
fun_int_2 = @(z,y) (m_v*delta)./(((T_em_maxspeed*y*v_max)./(rt*3.6.*z)) - F_attrito_50 - (((Cd*S_ev)/(21.15))*((3.6.*z).^(2))));


int_finale =@(x,y) integral(@(z) fun_int_1(z,x),0,(round(fsolve(@(z) fun_intersez_1_inc(z,x,y),10)/3.6)))... 
                  +integral(@(z) fun_int_2(z,y),(round(fsolve(@(z) fun_intersez_1_inc(z,x,y),10)/3.6)),27.8) +2;


x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[5.9,1.8];
Ub =[19.6,5.7];

nonlincon =@nlcon;

vel_0_100_migliore =fmincon(int_finale,x0,A,B,Aeq,Beq,lb,ub,nonlincon);






                         
                     
                         