%% grafico rendimenti secondo: Electric Vehicle Technology - James Larminie, John Lowry

clear
clc


prompt= '\Inserire valori manuali delle perdite o utilizzare valori di default (manuali -1, default-2)? ';
risposta= input(prompt);

%dati del nostro caso in studio (caso PP75)
% T_em =240; %[Nm]
% n_mot =7500; %[rpm]
% P_nom =75; %[kw]

%dati del nostro caso in studio (caso 2004 Prius)
T_em =302; %[Nm]
n_mot =6000; %[rpm]
P_nom =57; %[kw]

%faccio delle piccole trasformazioni (da rpm a rad/s)
n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s
% matrice_rendimenti =zeros ((T_em)+1,round(rad_s_i/2.5)+1); 

T_em_maxspeed =(30*P_nom*1000)/(pi*n_mot);
n_trans =(30*P_nom*1000)/(pi*T_em);

if risposta == 2
    
%prova manuale in cui cerco di rendere il codice james-lowry Generico
%dati relativi ai valori di riferimento
T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]
   
%%Valori relativi ad un tipico motore DC a magneti permanenti, CON spazzole
% x =linspace(1,180);% velocità, Nota Bene: [rad/s] NON [rpm]
% y =linspace(1,40); % coppia, espressa in [Nm], da 0 a 40 Nm
% % impostiamo i valori delle costanti di perdita del motore
% kc =1.5; % Perdita nel rame
% ki =0.1; % Perdita nel ferro
% kw =0.00001; % coefficiente di perdita nell'aria
% ConL =20; % perdita costante nel motore

%%Valori relativi ad un motore DC avente maggiore ponteza, maggiore velocità, SENZA spazzole
% rad_s_i =linspace(1,1000);% velocità, Nota Bene: [rad/s] NON [rpm] 
% T_em_i =linspace(1,250); % coppia, espressa in [Nm], da 0 a 40 Nm
% impostiamo i valori delle costanti di perdita del motore
kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

end

if risposta == 1
    
%dati del nostro caso in studio (caso PP75)    
% kc =0.087; % Perdita nel rame
% ki =8; % Perdita nel ferro
% kw =8e-7; % coefficiente di perdita nell'aria
% C =200; % perdita costante nel motore

%dati del nostro caso in studio (caso 2004 Prius)
kc =0.078; % Perdita nel rame
ki =4.3; % Perdita nel ferro
kw =100e-7; % coefficiente di perdita nell'aria
C =200; % perdita costante nel motore

end


matrice_rendimenti =zeros((T_em)+1,round(n_mot_rad_s)+1); 


if risposta == 2
%applico un primo ciclo for, in cui analizzo tutte le coppie da T=0 a T_em
for T_em_i=1:T_em
    
    
   if T_em_i <= T_em_maxspeed
      n_max_i =n_mot;
   else     
      n_max_i =(30*P_nom*1000)/(pi*T_em_i);
   end
   %trovata la velocita la trasformo subito in rad(s
   n_max_rad_i =n_max_i*(pi/30); %trasformo gli rpm in rad/s
    
   
   % vel_Tem_ =(0:2.5:n_max_rad_i);
   vel_Tem_ =(0:1:n_max_rad_i); %[rad/s]
   eta_i =zeros(size(vel_Tem_)); %soluzione ogni T_em
   
   
     for i=1:size(vel_Tem_,2)
       
        Output_power =vel_Tem_(i)*T_em_i; % Momento*velocità =Potenza [W]
        
        parte_1 =kc*(T_em_i^2)*((T_ref/T_em)^2); % Perdita nel rame
        parte_2 =ki*vel_Tem_(i)*(n_ref/n_mot_rad_s); % Perdita nel ferro
        parte_3 =kw*(vel_Tem_(i)^3)*((n_ref/n_mot_rad_s)^3); % coefficiente di perdita nell'aria
        power_loss =((T_em*n_mot_rad_s)/(T_ref*n_ref))*(parte_1+parte_2+parte_3+C);
        Input_power =Output_power+power_loss;
        
        Z_rend =Output_power/Input_power;
        eta_i(i) =Z_rend; %rendinento nel punto generico i [eta_i]
        
     end
   
     
matrice_rendimenti(T_em_i+1,1:size(eta_i,2)) =eta_i(1:end);
    
end


%%%calcolo grafico funzione rendimento
% creo la mesh 
vettore_x =(0:1:round(n_mot_rad_s));
vettore_y =(0:1:T_em);
[X,Y] =meshgrid(vettore_x,vettore_y);

Output_power =(X.*Y); % Momento*velocità =Potenza

parte_1 =kc*(Y.^2)*((T_ref/T_em)^2); % Perdita nel rame
parte_2 =ki*X*(n_ref/n_mot_rad_s); % Perdita nel ferro
parte_3 =kw*(X.^3)*((n_ref/n_mot_rad_s)^3); % coefficiente di perdita nell'aria
power_loss =((T_em*n_mot_rad_s)/(T_ref*n_ref)).*(parte_1+parte_2+parte_3+C);
Input_power =Output_power+power_loss;

Z_rend =(Output_power.*(Output_power<=(P_nom_ref*1000)))./Input_power;
end


if risposta == 1

for T_em_i=1:T_em
    
    
   if T_em_i <= T_em_maxspeed
      n_max_i =n_mot;
   else     
      n_max_i =(30*P_nom*1000)/(pi*T_em_i);
   end
   n_max_rad_i =n_max_i*(pi/30); %trasformo gli rpm in rad/s
    
   
   % vel_Tem_ =(0:2.5:n_max_rad_i);
   vel_Tem_ =(0:1:n_max_rad_i);
   eta_i =zeros(size(vel_Tem_)); %soluzione ogni T_em
   
   
     for i=1:size(vel_Tem_,2)
       
        Output_power =vel_Tem_(i)*T_em_i; % Momento*velocità =Potenza
        
        parte_1 =(T_em_i^2)*kc; % Perdita nel rame
        parte_2 =vel_Tem_(i)*ki; % Perdita nel ferro
        parte_3 =(vel_Tem_(i)^3)*kw; % coefficiente di perdita nell'aria
        Input_power =Output_power+parte_1+parte_2+parte_3+C;
        Z_rend =Output_power/Input_power;
       
        eta_i(i) =Z_rend; %rendinento nel punto generico i [eta_i]
        
     end
   
     
matrice_rendimenti(T_em_i+1,1:size(eta_i,2)) =eta_i(1:end);
    
end


%%%calcolo grafico funzione rendimento
% creo la mesh 
vettore_x =(0:1:round(n_mot_rad_s));
vettore_y =(0:1:T_em);
[X,Y] =meshgrid(vettore_x,vettore_y);

Output_power =(X.*Y); % Momento*velocità =Potenza
parte_1 =(Y.^2)*kc; % Perdita nel rame
parte_2 =X*ki; % Perdita nel ferro
parte_3 =(X.^3)*kw; % coefficiente di perdita nell'aria
Input_power =Output_power+parte_1+parte_2+parte_3+C;
Z_rend =(Output_power.*(Output_power<=(P_nom*1000)))./Input_power;

end
    
    
%PLOT
%Calcolo Grafico curve isorendimento
figure
box off
grid off
% Ora impostiamo le efficienze per le quali verrà tracciato un contorno.
V =[0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.75,0.8,0.85,0.90,0.91,0.92,0.925,0.93,0.95];
grafico_2 =contour(X,Y,Z_rend,V,'ShowText','on');
colorbar
colormap(turbo)
caxis([0 1]) %la color bar varia tra questi valori
xlabel('Speed/rad.s^-^1'), ylabel('Torque/N.m');
title('Grafico curve isorendimento motore') 

%Calcolo Grafico rendimento a colori
figure
grafico_3 =surf(X,Y,Z_rend);  
colorbar
colormap(turbo)
caxis([0 1]) %la color bar varia tra questi valori
grafico_3.EdgeColor = 'none';
xlabel('Speed/rad.s^-^1'), ylabel('Torque/N.m');
title('Grafico andamento rendimento motore') 
