%%%%%%%%%%%%% parte di codice in cui calcolo la velocita da 0-100
%Calcolo configurazione migliore vecolità 0-100 km/h

%la formula che andremo ad applicare è quella descritta a pag 279 del file "Capacity allocation of driving..."
%per prima cosa devo capire a quale velocità applicare il cambio da prima a seconda marcia.
%la coppia resistente considerata è quella di una macchina a "mezzo pieno carico", con una forza aerodinamica calcolata di 50 km/h.

%PER IL DEBUG (dati che servono per analizzare il caso specifico)
%variare solamente index e pedex per caèire il caso specifico
index =27;
pedex =4;

marcia.prima = i_1.min+(0.1*(index-1)); % (8.5) riga 27
marcia.seconda = matrice_rapporti(index,pedex); %(3.4) colonna 4
costante1_x =((2*pi)/60)*3.6*(rt/marcia.prima);
costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);

v_max_marcia1 =n_mot*costante1_x;
v_max_marcia2 =n_mot*costante2_x;
v_max_marce_max =max(v_max_marcia1,v_max_marcia2);
h =0.5; %lunghezza intervallo discretizzazione asse X [km/h]
vel_Tem_cambio =(0:h:v_max_marce_max);

T_em_marcia1 =T_em*marcia.prima;
T_em_marcia2 =T_em*marcia.seconda;

intervalli_T =254;
larghezza_intervallo_T =T_em/intervalli_T;
intervalli_n =400;
larghezza_intervallo_n =n_mot/intervalli_n;
%%%%%%%%%%%%%


%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
phi_50 =0;
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata

%Coppia erogata direttamente dal motore
Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
Tw_req_mot_kmh2 =Tw_req_50/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento


%trovata la coppia resistente mi calcolo la velocita in cui avviene il cambio
%andiamo da 0-100 ergo, dobbiamo trovare la velocità di cambio solamente in salita:


%CASO: POTENZA PERSA
%     if selez3 == 2
    %mi calcolo le velocità massime raggiungibili con queste coppie [in RPM]
    %le T_em_i che si trovano sotto il valore di T_em_maxspeed devono avere un max di n_max_i pari a n_mot, sennò andrebbe ad infinito
       if Tw_req_mot_kmh1 <= T_em_maxspeed
         n_max_kmh_i1 =n_mot;
       else     
         n_max_kmh_i1 =(30*P_nom*1000)/(pi*Tw_req_mot_kmh1);
       end

       if Tw_req_mot_kmh2 <= T_em_maxspeed
         n_max_kmh_i2 =n_mot;
       else     
         n_max_kmh_i2 =(30*P_nom*1000)/(pi*Tw_req_mot_kmh2);
       end

    %capisco quanti intervalli devo avere in ogni riga (poiche la velocità max cambia per ogni T_em_i, non è sempre uguale)
    %floor mi approssima per divetto l'ultimo indice dell'ultima velocità
    v_end_kmh_1 =floor((n_max_kmh_i1*costante1_x)/h); %indice velocita finale discretizzazione in [km/h]
    eta_kmh_i1_pp =zeros(6,v_end_kmh_1); %soluzione ogni T_em    
     
    v_end_kmh_2 =floor((n_max_kmh_i2*costante2_x)/h); %indice velocita finale discretizzazione in [km/h]
    eta_kmh_i2_pp =zeros(6,v_end_kmh_2); %soluzione ogni T_em (quindi ogni iterazione su alfa)
    %da NOTARE: v_end_1_1 e v_end_1_2 vengono uguali perche è la velocità max nel grafico composto a coppia_i_marcia1

    %applico un secondo ciclo for in cui analizzo le velocità da n_mot=0 a n_max relativa al valore di coppia in esame nel ciclo
      for i=1:v_end_kmh_1

         %devo trasformare la vel da km/h a rpm, e poi da rpm in rad/s (per poterla utilizzare nella formula delle potenze)
         vel_Tem_cambio_km_i =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
         
         P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i; %potenza del motore nel punto i generico [W]

         parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
         parte_2 =kc*(Tw_req_mot_kmh1^2)*(T_ref/T_em)^2;
         parte_3 =ki*vel_Tem_cambio_km_i*(n_ref/n_mot_rad_s);
         parte_4 =kw*(vel_Tem_cambio_km_i^3)*(n_ref/n_mot_rad_s)^3;

         P_loss_i =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]

         eta_kmh_i1_pp(1,i) =P_em_i/(P_em_i+P_loss_i); %rendinento nel punto generico i [eta_i]
         eta_kmh_i1_pp(2,i) =vel_Tem_cambio(i)/costante1_x; %individuo il valore del numero di giri del motore relativo al rendimento identificato [rpm]
         eta_kmh_i1_pp(3,i) =vel_Tem_cambio(i); %velocità espressa in [km/h]
         eta_kmh_i1_pp(4,i) =vel_Tem_cambio_km_i; %numero di giri espresso in [rad/s]
         eta_kmh_i1_pp(5,i) =P_em_i; %Potenza erogata [W]
         eta_kmh_i1_pp(6,i) =P_loss_i; %Potenza Persa [W]

      end

      for i=1:v_end_kmh_2

         %devo trasformare la vel da km/h a rpm, e poi da rpm in rad/s (per poterla utilizzare nella formula delle potenze)
         vel_Tem_cambio_km_i =(vel_Tem_cambio(i)/costante2_x)*(pi/30);
         
         P_em_i =Tw_req_mot_kmh2*vel_Tem_cambio_km_i; %potenza del motore nel punto i generico [W]

         parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
         parte_2 =kc*(Tw_req_mot_kmh2^2)*(T_ref/T_em)^2;
         parte_3 =ki*vel_Tem_cambio_km_i*(n_ref/n_mot_rad_s);
         parte_4 =kw*(vel_Tem_cambio_km_i^3)*(n_ref/n_mot_rad_s)^3;

         P_loss_i =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [kW]

         eta_kmh_i2_pp(1,i) =P_em_i/(P_em_i+P_loss_i); %rendinento nel punto generico i [eta_i]
         eta_kmh_i2_pp(2,i) =vel_Tem_cambio(i)/costante2_x; %numero di giri espresso in [rpm]
         eta_kmh_i2_pp(3,i) =vel_Tem_cambio(i); %velocità espressa in [km/h]
         eta_kmh_i2_pp(4,i) =vel_Tem_cambio_km_i; %numero di giri espresso in [rad/s]
         eta_kmh_i2_pp(5,i) =P_em_i; %Potenza erogata [W]
         eta_kmh_i2_pp(6,i) =P_loss_i; %Potenza Persa [W]

      end

    figure
    Grafico_16 =plot(vel_Tem_cambio(1:v_end_kmh_1),eta_kmh_i1_pp(1,:),'b-',vel_Tem_cambio(1:v_end_kmh_2),eta_kmh_i2_pp(1,:),'r-');
    title(['Andamento rendimento motore con coppia resistente pari a: ',num2str(Tw_req_50)])
    xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');
    legend('cruva di efficienza EM marcia-1','cruva di efficienza EM marcia-2')
    ylim([0 1]) %viene meglio il grafico se metto un limite sull'asse y [rendimento]
    xlim([0 v_max_marce_max]) %viene meglio il grafico se metto un limite sull'asse x [km/h]

    
      %PUNTO INTERSEZIONE COL METODO DELLA POTENZA PERSA
%     if selez3 ==2
      %confronto le due curve ottenute e ricavo il punto di incrocio marcia salita
      diff_dim =abs(size(eta_kmh_i2_pp,2)-size(eta_kmh_i1_pp,2));
    
      %mi creo vettori aventi la stessa lunghezza
      if size(eta_kmh_i1_pp,2) >= size(eta_kmh_i2_pp,2)
          eta_i2_kmh_new_pp =2*ones(1,size(eta_kmh_i2_pp,2)+diff_dim);
          eta_i2_kmh_new_pp(1,1:size(eta_kmh_i2_pp,2)) =eta_kmh_i2_pp(1,1:end);
          legge_cambio_kmh1_pp =eta_kmh_i1_pp(1,1:end)-eta_i2_kmh_new_pp(1,1:end);
      else %size(eta_1_i1,2) < size(eta_1_i2,2)
          eta_i1_kmh_new_pp =2*ones(1,size(eta_kmh_i1_pp,2)+diff_dim);
          eta_i1_kmh_new_pp(1,1:size(eta_kmh_i1_pp,2)) =eta_kmh_i1_pp(1,1:end);
          legge_cambio_kmh1_pp =eta_kmh_i2_pp(1,1:end)-eta_i1_kmh_new_pp(1,1:end);
      end
      
      
      flag_2 =0; %è un indicatore che mi serve per identificare il caso in cui non ho mai intersezione tra le curve
    
    %trovo il punto di intersezione delle due rette
    for i =1:(size(legge_cambio_kmh1_pp,2)-1)
      if flag_2 ==0 %devo salvarmi il primo risultato di intersezione
      %infatti, nel caso in cui i rendimenti sono inseriti a mano, potrebbero esserci dei passaggi ambigui in cui 
      %nella "legge_cambio_i1" tra i e i+1 si cambia segno (a causa di come è stato scritto il programma), e non voglio prenderlo
        if legge_cambio_kmh1_pp(1,i)<0 && legge_cambio_kmh1_pp(1,i+1)>0 && legge_cambio_kmh1_pp(1,i+1)<1
           x_punto_1_4 =(i-1)/2;
           y_punto_1 =eta_kmh_i1_pp(1,i);
           y_punto_4 =eta_kmh_i2_pp(1,i);
           x_punto_2_3 =(i)/2;
           y_punto_2 =eta_kmh_i1_pp(1,i+1);
           y_punto_3 =eta_kmh_i2_pp(1,i+1);
           flag_2 =1; %ho trovato l'intersezione
        elseif legge_cambio_kmh1_pp(1,i)>0 && legge_cambio_kmh1_pp(1,i+1)<0 && abs(legge_cambio_kmh1_pp(1,i+1))<1
           x_punto_1_4 =(i-1)/2;
           y_punto_1 =eta_kmh_i1_pp(1,i);
           y_punto_4 =eta_kmh_i2_pp(1,i);
           x_punto_2_3 =(i)/2;
           y_punto_2 =eta_kmh_i1_pp(1,i+1);
           y_punto_3 =eta_kmh_i2_pp(1,i+1);
           flag_2 =1; %ho trovato l'intersezione
        end
      end
    end
    
    vel_cambio_kmh_pp =zeros(2,1);
    
    if flag_2 == 0 %non ho trovato punto di intersezione
       vel_cambio_kmh_pp(1) =0; %rimango sempre in prima
       
    else %flag_2 == 1 %ho trovato punto di intersezione
       vel_cambio_kmh_pp(1) =(y_punto_3-y_punto_1+(x_punto_1_4*((y_punto_2-y_punto_1)/(x_punto_2_3-x_punto_1_4)))+...
                          (x_punto_2_3*((y_punto_3-y_punto_4)/(x_punto_1_4-x_punto_2_3))))/...
                          (((y_punto_2-y_punto_1)/(x_punto_2_3-x_punto_1_4))-((y_punto_4-y_punto_3)/(x_punto_1_4-x_punto_2_3)));
       vel_cambio_kmh_pp(2) =y_punto_1+(((vel_cambio_kmh_pp(1)-x_punto_1_4)/...
                          (x_punto_2_3-x_punto_1_4))*(y_punto_2-y_punto_1));
    end


    %CASO: INSERIMENTO DATI RENDIMENTO MANUALE
%     if selez3 == 1
         
         %CASO 1_i1
         %prealloco spazio per il valore interpolato su T dei rendimenti e sulle velocità
         rend_T_interpolata_i1_kmh =zeros(1,(n_mot/25)+1);
         eta_kmh_i1_im =zeros(4,floor(n_mot/25)+1);
         
         %devo capire che coppia devo prendere in considerazione
         indice_indagine =(Tw_req_mot_kmh1/larghezza_intervallo_T)+1; %sommo 1 perche gli indici partono da 1 e non da 0
         
         %devo suddividere il caso in cui becco l'esatta posizione nella matrice_rendimenti e quando interpolare
         if mod(Tw_req_mot_kmh1,larghezza_intervallo_T) ==0 || mod(Tw_req_mot_kmh1,larghezza_intervallo_T) <10e-6 %ho trovato il valore nella griglia
             dim_indice =sum(matrice_rendimenti(round(indice_indagine),:) ~= 0)+1;
             for j=1:dim_indice %itero per le velocità
                 rend_T_interpolata_i1_kmh(1,j) =matrice_rendimenti(round(indice_indagine),j);
             end
         else %caso in cui interpolare
             %capisco tra quali estremi interpolare
             indice_superiore =ceil(indice_indagine);
             indice_inferiore =floor(indice_indagine);
             
             dim_indice_superiore =sum(matrice_rendimenti(indice_superiore,:) ~= 0)+1;
             dim_indice_inferiore =sum(matrice_rendimenti(indice_inferiore,:) ~= 0)+1;
             dim_indice =min(dim_indice_superiore,dim_indice_inferiore);
             
             %salvo i valori interpolati rispetto alla T
             for j=1:dim_indice %itero per le velocità
                 rend_T_interpolata_i1_kmh(1,j) =(((indice_indagine-indice_superiore)/(indice_inferiore-indice_superiore))*matrice_rendimenti(indice_inferiore,j))-...
                                          (((indice_indagine-indice_inferiore)/(indice_inferiore-indice_superiore))*matrice_rendimenti(indice_superiore,j));
             end
         end
         
         %Adesso ho la riga con l'esatto valore di coppia sulla quale calcolare i rendimenti per le varie velocità
         valore_di_cambio =(n_mot/intervalli_n)/25;
         
         for k=1:intervalli_n
             %Estremi di velocità all'interno della quale calcolare il valore dei rendimenti
             n_a =(k-1)*(n_mot/intervalli_n); %vel in [rpm]
             y_a =rend_T_interpolata_i1_kmh(1,k); %rendimento
             
             n_b =(k)*(n_mot/intervalli_n); %vel in [rpm]
             y_b =rend_T_interpolata_i1_kmh(1,k+1); %rendimento
             
             for y=1:valore_di_cambio
                 if y == 1
                    eta_kmh_i1_im(1,(1+((k-1)*valore_di_cambio))) =rend_T_interpolata_i1_kmh(1,k); %rendinento nel punto generico i [eta_i]
                    eta_kmh_i1_im(2,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i1_im(1,(1+((k-1)*valore_di_cambio))) ~= 0)*(k-1)*25*valore_di_cambio; %numero di giri espresso in [rpm]
                    eta_kmh_i1_im(3,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i1_im(2,(1+((k-1)*valore_di_cambio))))*costante1_x; %velocità espressa in [km/h]
                    eta_kmh_i1_im(4,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i1_im(2,(1+((k-1)*valore_di_cambio))))*(pi/30); %numero di giri espresso in [rad/s]
  
                 else
                    n_iterazione =((k-1)*(n_mot/intervalli_n))+(y-1)*25;
                    eta_kmh_i1_im(1,(((k-1)*valore_di_cambio)+y)) =(((n_iterazione-n_b)/(n_a-n_b))*y_a)-(((n_iterazione-n_a)/(n_a-n_b))*y_b); %rendinento nel punto generico i [eta_i]
                    eta_kmh_i1_im(2,(((k-1)*valore_di_cambio)+y)) =(eta_kmh_i1_im(1,(((k-1)*valore_di_cambio)+y)) ~= 0)*(((k-1)*(n_mot/intervalli_n))+y*25); %numero di giri espresso in [rpm]
                    eta_kmh_i1_im(3,(((k-1)*valore_di_cambio)+y)) =(eta_kmh_i1_im(2,(((k-1)*valore_di_cambio)+y)))*costante1_x; %velocità espressa in [km/h]
                    eta_kmh_i1_im(4,(((k-1)*valore_di_cambio)+y)) =(eta_kmh_i1_im(2,(((k-1)*valore_di_cambio)+y)))*(pi/30); %numero di giri espresso in [rad/s]
                 end
                 
             end 
             
         end
         
         
         %CASO 1_i2
         %prealloco spazio per il valore interpolato su T dei rendimenti e sulle velocità (caso 1_i2)
         rend_T_interpolata_i2_kmh =zeros(1,(n_mot/25)+1);
         eta_kmh_i2_im =zeros(4,(n_mot/25)+1);
         
         %devo capire che coppia devo prendere in considerazione
         indice_indagine =(Tw_req_mot_kmh2/larghezza_intervallo_T)+1; %sommo 1 perche gli indici partono da 1 e non da 0
         
         %devo suddividere il caso in cui becco l'esatta posizione nella matrice_rendimenti e quando interpolare
         if mod(Tw_req_mot_kmh2,larghezza_intervallo_T) ==0 || mod(Tw_req_mot_kmh2,larghezza_intervallo_T) < 10e-6 %ho trovato il valore nella griglia
             dim_indice =sum(matrice_rendimenti(round(indice_indagine),:) ~= 0)+1;
             for j=1:dim_indice %itero per le velocità
                 rend_T_interpolata_i2_kmh(1,j) =matrice_rendimenti(round(indice_indagine),j);
             end
         else %caso in cui interpolare
             %capisco tra quali estremi interpolare
             indice_superiore =ceil(indice_indagine);
             indice_inferiore =floor(indice_indagine);
             
             dim_indice_superiore =sum(matrice_rendimenti(indice_superiore,:) ~= 0)+1;
             dim_indice_inferiore =sum(matrice_rendimenti(indice_inferiore,:) ~= 0)+1;
             dim_indice =min(dim_indice_superiore,dim_indice_inferiore);
   
             %salvo i valori interpolati rispetto alla T
             for j=1:dim_indice %itero per le velocità
                 rend_T_interpolata_i2_kmh(1,j) =(((indice_indagine-indice_superiore)/(indice_inferiore-indice_superiore))*matrice_rendimenti(indice_inferiore,j))-...
                                          (((indice_indagine-indice_inferiore)/(indice_inferiore-indice_superiore))*matrice_rendimenti(indice_superiore,j));
             end
         end
         
         %Adesso ho la riga con l'esatto valore di coppia sulla quale calcolare i rendimenti per le varie velocità
         valore_di_cambio =(n_mot/intervalli_n)/25;
         
         for k=1:intervalli_n
             %Estremi di velocità all'interno della quale calcolare il valore dei rendimenti
             n_a =(k-1)*(n_mot/intervalli_n); %vel in [rpm]
             y_a =rend_T_interpolata_i2_kmh(1,k); %rendimento
             
             n_b =(k)*(n_mot/intervalli_n); %vel in [rpm]
             y_b =rend_T_interpolata_i2_kmh(1,k+1); %rendimento
             
             for y=1:valore_di_cambio
                 if y == 1
                    eta_kmh_i2_im(1,(1+((k-1)*valore_di_cambio))) =rend_T_interpolata_i2_kmh(1,k); %rendinento nel punto generico i [eta_i]
                    eta_kmh_i2_im(2,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i2_im(1,(1+((k-1)*valore_di_cambio))) ~= 0)*(k-1)*25*valore_di_cambio; %numero di giri espresso in [rpm]
                    eta_kmh_i2_im(3,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i2_im(2,(1+((k-1)*valore_di_cambio))))*costante2_x; %velocità espressa in [km/h]
                    eta_kmh_i2_im(4,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i2_im(2,(1+((k-1)*valore_di_cambio))))*(pi/30); %numero di giri espresso in [rad/s]
                 else
                    n_iterazione =((k-1)*(n_mot/intervalli_n))+(y-1)*25;
                    eta_kmh_i2_im(1,(((k-1)*valore_di_cambio)+y)) =(((n_iterazione-n_b)/(n_a-n_b))*y_a)-(((n_iterazione-n_a)/(n_a-n_b))*y_b); %rendinento nel punto generico i [eta_i]
                    eta_kmh_i2_im(2,(((k-1)*valore_di_cambio)+y)) =(eta_kmh_i2_im(1,(((k-1)*valore_di_cambio)+y)) ~= 0)*(((k-1)*(n_mot/intervalli_n))+y*25); %numero di giri espresso in [rpm]
                    eta_kmh_i2_im(3,(((k-1)*valore_di_cambio)+y)) =(eta_kmh_i2_im(2,(((k-1)*valore_di_cambio)+y)))*costante2_x; %velocità espressa in [km/h]
                    eta_kmh_i2_im(4,(1+((k-1)*valore_di_cambio))) =(eta_kmh_i2_im(2,(1+((k-1)*valore_di_cambio))))*(pi/30); %numero di giri espresso in [rad/s]
                 end
                 
             end 
             
         end

%     end


          %PUNTO INTERSEZIONE COL METODO DEGLI INSERIMENTI MANUALI
          %devo trasformare i dati ottenuti rispetto alla velocità in km/h piuttosto che rispetto ai RPM.
          %infatti, le marce vanno valutate sulla velocita del veicolo e non sui giri motore del motore stesso
          
          %%Marcia 1_1
          fine_kmh1_1 =sum(eta_kmh_i1_im(2,:) ~= 0)+1;
          index_kmh1_1 =floor((eta_kmh_i1_im(3,fine_kmh1_1))/0.5);
          eta_kmh_i1_new_im =zeros(3,index_kmh1_1);
          
          for i=1:index_kmh1_1
              velocita_interaz =i*0.5;
              %parte in cui faccio la media ponderata
                flag_4 =0;
                j =1;
                while flag_4 ==0
                  %devo capire dove fare l'iterazione
                  if velocita_interaz > eta_kmh_i1_im(3,j) && velocita_interaz < eta_kmh_i1_im(3,j+1)
                     n_a =eta_kmh_i1_im(3,j);
                     y_a =eta_kmh_i1_im(1,j);
                     n_b =eta_kmh_i1_im(3,j+1);
                     y_b =eta_kmh_i1_im(1,j+1);
                     
                     eta_kmh_i1_new_im(1,i+1) =((((i*0.5)-n_b)/(n_a-n_b))*y_a)-((((i*0.5)-n_a)/(n_a-n_b))*y_b); %rendimento [eta_i]
                     eta_kmh_i1_new_im(2,i+1) =velocita_interaz/costante1_x; %velocita [rpm]
                     eta_kmh_i1_new_im(3,i+1) =velocita_interaz; %velocita [km/h]
                     flag_4 =1;
                  end
                  j =j+1;
                end
          end
          
          
          %%Marcia 1_2
          fine_kmh1_2 =sum(eta_kmh_i2_im(2,:) ~= 0)+1;
          index_kmh1_2 =floor((eta_kmh_i2_im(3,fine_kmh1_2))/0.5);
          eta_kmh_i2_new_im =zeros(3,index_kmh1_2);
        
          for i=1:index_kmh1_2
              velocita_interaz =i*0.5;
              %parte in cui faccio la media ponderata
                flag_4 =0;
                j =1;
                while flag_4 ==0
                  %devo capire dove fare l'iterazione
                  if velocita_interaz > eta_kmh_i2_im(3,j) && velocita_interaz < eta_kmh_i2_im(3,j+1)
                     n_a =eta_kmh_i2_im(3,j);
                     y_a =eta_kmh_i2_im(1,j);
                     n_b =eta_kmh_i2_im(3,j+1);
                     y_b =eta_kmh_i2_im(1,j+1);
                     
                     eta_kmh_i2_new_im(1,i+1) =((((i*0.5)-n_b)/(n_a-n_b))*y_a)-((((i*0.5)-n_a)/(n_a-n_b))*y_b); %rendimento [eta_i]
                     eta_kmh_i2_new_im(2,i+1) =velocita_interaz/costante2_x; %velocita [rpm]
                     eta_kmh_i2_new_im(3,i+1) =velocita_interaz; %velocita [km/h]
                     flag_4 =1;
                  end
                  j =j+1;
                end
          end
        
        
      diff_dim =abs(size(eta_kmh_i2_new_im,2)-size(eta_kmh_i1_new_im,2));
    
      %mi creo vettori aventi la stessa lunghezza
      if size(eta_kmh_i1_new_im,2) >= size(eta_kmh_i2_new_im,2)
          eta_kmh_i2_new2_im =2*ones(3,size(eta_kmh_i2_new_im,2)+diff_dim);
          eta_kmh_i2_new2_im(1,1:size(eta_kmh_i2_new_im,2)) =eta_kmh_i2_new_im(1,1:end);
          legge_cambio_kmh1_im =eta_kmh_i1_new_im(1,1:end)-eta_kmh_i2_new2_im(1,1:end);
      else %size(eta_1_i1,2) < size(eta_1_i2,2)
          eta_kmh_i1_new2_im =2*ones(3,size(eta_kmh_i1_new_im,2)+diff_dim);
          eta_kmh_i1_new2_im(1,1:size(eta_kmh_i1_new_im,2)) =eta_kmh_i1_new_im(1,1:end);
%           eta_i1_1_new2_im(2,1:size(eta_1_i1_new_im,2)) =eta_1_i1_new_im(2,1:end);
%           eta_i1_1_new2_im(3,1:size(eta_1_i1_new_im,2)) =eta_1_i1_new_im(3,1:end);
          legge_cambio_kmh1_im =eta_kmh_i2_new_im(1,1:end)-eta_kmh_i1_new2_im(1,1:end);
      end
          
        
    flag_2 =0; %è un indicatore che mi serve per identificare il caso in cui non ho mai intersezione tra le curve
    
    %trovo il punto di intersezione delle due rette
    for i =1:(size(legge_cambio_kmh1_im,2)-1)
      if flag_2 ==0 %devo salvarmi il primo risultato di intersezione
      %infatti, nel caso in cui i rendimenti sono inseriti a mano, potrebbero esserci dei passaggi ambigui in cui 
      %nella "legge_cambio_i1" tra i e i+1 si cambia segno (a causa di come è stato scritto il programma), e non voglio prenderlo
        if legge_cambio_kmh1_im(1,i)<0 && legge_cambio_kmh1_im(1,i+1)>0 && legge_cambio_kmh1_im(1,i+1)<1
           x_punto_1_4 =(i-1)/2;
           y_punto_1 =eta_kmh_i1_new_im(1,i);
           y_punto_4 =eta_kmh_i2_new_im(1,i);
           x_punto_2_3 =i/2;
           y_punto_2 =eta_kmh_i1_new_im(1,i+1);
           y_punto_3 =eta_kmh_i2_new_im(1,i+1);
           flag_2 =1; %ho trovato l'intersezione
        elseif legge_cambio_kmh1_im(1,i)>0 && legge_cambio_kmh1_im(1,i+1)<0 && abs(legge_cambio_kmh1_im(1,i+1))<1
           x_punto_1_4 =(i-1)/2;
           y_punto_1 =eta_kmh_i1_new_im(1,i);
           y_punto_4 =eta_kmh_i2_new_im(1,i);
           x_punto_2_3 =i/2;
           y_punto_2 =eta_kmh_i1_new_im(1,i+1);
           y_punto_3 =eta_kmh_i2_new_im(1,i+1);
           flag_2 =1; %ho trovato l'intersezione
        end
      end
    end
    
    vel_cambio_kmh_im =zeros(2,1);
    
    if flag_2 == 0 %non ho trovato punto di intersezione
       vel_cambio_kmh_im(1) =0; %rimango sempre in prima
       vel_cambio_kmh_im(2) =0;
       
    else %flag_2 == 1 %ho trovato punto di intersezione
    vel_cambio_kmh_im(1) =(y_punto_3-y_punto_1+(x_punto_1_4*((y_punto_2-y_punto_1)/(x_punto_2_3-x_punto_1_4)))+...
                          (x_punto_2_3*((y_punto_3-y_punto_4)/(x_punto_1_4-x_punto_2_3))))/...
                          (((y_punto_2-y_punto_1)/(x_punto_2_3-x_punto_1_4))-((y_punto_4-y_punto_3)/(x_punto_1_4-x_punto_2_3)));
    vel_cambio_kmh_im(2) =y_punto_1+(((vel_cambio_kmh_im(1)-x_punto_1_4)/...
                          (x_punto_2_3-x_punto_1_4))*(y_punto_2-y_punto_1));
    end      
      
    
%     end   


%una volta trovata la velocità in cui cambiare la marcia, possiamo utilizzare la formula integrale per calcolarci il tempo impiegato per passare da 0-100 km/h
%mi calcolo la coppia max resistente in salita

% F_aerodinamica_1 =0.5*rho_aria*Cd*S_ev*((v_climb/3.6)^2);
% F_attrito_1 =f_volv*m_v*g*cosd(phi);
% F_climbing_1 =m_v*g*sind(phi);

% F_aerodinamica_2 =0.5*rho_aria*Cd*S_ev*((v_max*(1000/3600))^2);
% F_attrito_2 =f_volv*m_v*g;

F_tot_climb =F_attrito_1+F_climbing_1+F_aerodinamica_1;
F_tot_marcia2 =F_aerodinamica_2+F_attrito_2;
T_max_climb_1 =(F_tot_climb*rt)/(eta_pt*marcia.prima*i_0tr);
T_max_climb_2 =(F_tot_marcia2*rt)/(eta_pt*marcia.seconda*i_0tr);

%massa_equivalente_veicolo =(massa_a_vuoto*delta)+massa_passeggero+massa_accessori;
%inserisco la funzione integranda

% fun_1 = @(x) (m_v*delta)./(  ((T_em_marcia1*v_climb)./(rt*3.6.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*x).^(2)) )  );
% fun_2 = @(x) (m_v*delta)./(  ((T_em_marcia2*v_max)./(rt*3.6.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*x).^(2)) )  );

fun_1 = @(x) (m_v*delta)./(  ((T_em_marcia1*v_climb)./(rt*3.6.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*x).^(2)) )  );

% fun_2 = @(x) (m_v*delta)./(  ((T_em_marcia2*n_trans_2)./(rt*3.6.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*x).^(2)) )  );
fun_2 = @(x) (m_v*delta)./(  ((T_em_maxspeed*marcia.seconda*v_max)./(rt*3.6.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*((3.6.*x).^(2)) )  );


vel_cambio_kmh_intermedia =round(vel_cambio_kmh_pp(1)/3.6,1); % [m/s]
vel_kmh_finale =27.8; %100 [Km/h] espresso in [m/s]

Int_0_velcambio_kmh =integral( fun_1,0,vel_cambio_kmh_intermedia );
Int_velcambio_100_kmh =integral( fun_2,vel_cambio_kmh_intermedia,vel_kmh_finale );
tempo_cambio =2; %impiego circa 2 secondi a fare un cambio marcia

%matrice_0_100(index,pedex) =Int_0_velcambio_kmh+Int_velcambio_100_kmh+tempo_cambio;
risposta =Int_0_velcambio_kmh+Int_velcambio_100_kmh+tempo_cambio; %per la parte di debug

fprintf ('\nIl tempo teorico che il veicolo impiega per passare da 0-100 km/h (con i_marcia-1: %.2f, i_marcia-2: %.2f) è circa di %.2f secondi\n\n', marcia.prima, marcia.seconda, risposta); %matrice_0_100(index,pedex) per la parte di debug

%%%%%%%%%%%%% fine parte di codice in cui calcolo la velocita da 0-100






