%%%%%%%%%%%%% parte di codice in cui calcolo la velocita da 0-100
%Calcolo configurazione migliore vecolità 0-100 km/h

%la formula che andremo ad applicare è quella descritta a pag 279 del file "Capacity allocation of driving..."
%per prima cosa devo capire a quale velocità applicare il cambio da prima a seconda marcia.
%la coppia resistente considerata è quella di una macchina a "mezzo pieno carico", con una forza aerodinamica calcolata di 50 km/h.

%PER IL DEBUG (dati che servono per analizzare il caso specifico)
%variare solamente index e pedex per caèire il caso specifico
index =62; %(62) (63) 27
pedex =12; %(4) (13) 4

%vel_cambio(10, 4.5455, 80, 254, 10000, 0.3150)

marcia.prima = i_1.min+(0.1*(index-1)); % (8.5) riga 27
marcia.seconda = matrice_rapporti(index,pedex); %(3.4) colonna 4
costante1_x =((2*pi)/60)*3.6*(rt/marcia.prima);
costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);

v_max_marcia1 =n_mot*costante1_x;
v_max_marcia2 =n_mot*costante2_x;
v_max_marce_max =max(v_max_marcia1,v_max_marcia2);
h =0.5; %lunghezza intervallo discretizzazione asse X [km/h]
vel_Tem_cambio =(0:h:v_max_marce_max);

T_em_marcia1 =T_em*marcia.prima;
T_em_marcia2 =T_em*marcia.seconda;

intervalli_T =254;
larghezza_intervallo_T =T_em/intervalli_T;
intervalli_n =400;
larghezza_intervallo_n =n_mot/intervalli_n;

T_em_maxspeed_1 =T_em_maxspeed*marcia.prima;
T_em_maxspeed_2 =T_em_maxspeed*marcia.seconda;

% n_trans =(30*P_nom*1000)./(pi*T_em);
n_trans_1 =n_trans*costante1_x;
n_trans_2 =n_trans*costante2_x;


%Calcolo curve isorendimento (marcia-1)
figure
box off
grid off
X_1 =ascissa*3.6*(rt/marcia.prima);
Y_1 =ordinata*marcia.prima;
curve =[0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.75,0.8,0.85,0.90,0.91,0.92,0.925,0.93,0.95];
grafico_4 =contour(X_1,Y_1,Z_rend,curve,'ShowText','on');
colorbar
colormap(turbo)
xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');
title('Grafico curve isorendimento motore - marcia 1') 

%calcolo grafico rendimento (marcia-1)
figure
X_1 =ascissa*3.6*(rt/marcia.prima);
Y_1 =ordinata*marcia.prima;
grafico_5 =surf(X_1,Y_1,Z_rend);  
colorbar
colormap(turbo)
caxis([0 1]) %la color bar varia tra questi valori
grafico_5.EdgeColor = 'none';
xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');
title('Grafico andamento rendimento motore - marcia 1') 


%Calcolo curve isorendimento (marcia-2)
figure
box off
grid off
X_2 =ascissa*3.6*(rt/marcia.seconda);
Y_2 =ordinata*marcia.seconda;
curve =[0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.75,0.8,0.85,0.90,0.91,0.92,0.925,0.93,0.95];
grafico_6 =contour(X_2,Y_2,Z_rend,curve,'ShowText','on');
colorbar
colormap(turbo)
caxis([0 1]) %la color bar varia tra questi valori
xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');
title('Grafico curve isorendimento motore - marcia 2')  

%calcolo grafico rendimento (marcia-2)
figure
X_1 =ascissa*3.6*(rt/marcia.seconda);
Y_1 =ordinata*marcia.seconda;
grafico_7 =surf(X_1,Y_1,Z_rend);  
colorbar
colormap(turbo)
caxis([0 1]) %la color bar varia tra questi valori
grafico_7.EdgeColor = 'none';
xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');
title('Grafico andamento rendimento motore - marcia 2') 


%grafico per comprendere la zona di sovrapposizione delle zone lavoro marcia-1 e marcia-2

% n_trans_1 =n_trans*costante1_x;
x1_1 =linspace(0,n_trans_1,10000);
T_funz_Tmax_1 =T_em_marcia1+x1_1*0;
x2_1 =linspace(n_trans_1,n_mot*costante1_x,10000);
T_funz_1 =((30*P_nom*1000)./(pi*x2))*marcia.prima;

% T_em_maxspeed_1 =((30*P_nom*1000)/(pi*n_mot))*marcia.prima;
y1_1 =linspace(T_em_maxspeed_1,0,1000);
x3_1 =(n_mot*costante1_x)*ones(1,1000);
T_funz_nmax_1 =y1_1+x3_1*0;

% n_trans_2 =n_trans*costante2_x;
x1_2 =linspace(0,n_trans_2,10000);
T_funz_Tmax_2 =T_em_marcia2+x1_2*0;
x2_2 =linspace(n_trans_2,n_mot*costante2_x,10000);
T_funz_2 =((30*P_nom*1000)./(pi*x2))*marcia.seconda;

% T_em_maxspeed_2 =((30*P_nom*1000)/(pi*n_mot))*marcia.seconda;
y1_2 =linspace(T_em_maxspeed_2,0,1000);
x3_2 =(n_mot*costante2_x)*ones(1,1000);
T_funz_nmax_2 =y1_2+x3_2*0;

%grafico sovrapposizione momento torcente motore
figure
Grafico_8 =plot(x1_1,T_funz_Tmax_1,'b-',x2_1,T_funz_1,'b-',x3_1,y1_1,'b--',x1_2,T_funz_Tmax_2,'r-',x2_2,T_funz_2,'r-',x3_2,y1_2,'r--');
title(['Grafico sovrapposizione cruva marcia_1:' num2str(marcia.prima) ', curva marcia_2:' num2str(marcia.seconda)])
legend('cruva marcia-1','','','cruva marcia-2')
xlabel('Speed/km.h^-^1'), ylabel('Torque/N.m');


%%%%%%%%%%%%%


%calcolo le forze che entrano in gioco per trovare la coppia resistente (cerco velocità di cambio)
phi_50 =0;
F_aerodinamica_50 =0.5*rho_aria*Cd*S_ev*((50/3.6)^2); %forza aerodinamica alla velocità media di 50 km/h
F_attrito_50 =f_volv*m_v_1*g*cosd(phi_50);
F_climbing_50 =m_v_1*g*sind(phi_50);

F_req_50 =F_aerodinamica_50+F_attrito_50+F_climbing_50;
Tw_req_50 =F_req_50*rt; %[Nm] coppia resistente con marcia-1 ingranata


%%%%%%%%%%%%%%%

vel_kmh_finale =100/3.6; %100 [Km/h] espresso in [m/s]
tempo_cambio =0.5; %impiego circa 2 secondi a fare un cambio marcia


%ho il pedale tutto schiacciato, alfa =1, perche sto dando tutto per raggiungere 100 km/h
%la domanda è: applico un cambio oppure rimango in prima? dipende dal rendimento
if n_trans_2 >= 100
    %significa che il cambio può avvenire solo per velocità superiori a 100 km/h
    %ergo tutto l'esperimento viene fatto in prima
%   fun_1 = @(x) (m_v*delta)./(  ((T_em*marcia.prima*eta_pt)./rt) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    fun_1 = @(x) (m_v*delta)./(  ((T_em*marcia.prima*eta_pt)./rt) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    
    %fun_1_2 = @(x) (m_v*delta)./(  ((T_em_marcia1*v_climb/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    fun_1_2 = @(x) (m_v*delta)./(  ((T_em_marcia1*n_trans_1/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );

    int_1 =integral( fun_1,0,n_trans_1/3.6 );
    Int_2 =integral( fun_1_2,n_trans_1/3.6,vel_kmh_finale );
    risposta =int_1+Int_2; %per la parte di debug

else
    %significa che il cambio puo avvenire per velocita inferiori a 100 km/h.
    %dobbiamo capire, a quale velocita, conviene passare dalla marcia 1 alla marcia 2
    %rimanendo sulla curva a potenza costante, per ogni valore di coppia mi calcolo il rdimento e lo confronto con quello della marcia 1
    
    if n_trans_2 >= v_max_marcia1
        %caso particolare
        vel_cambio_ms_intermedia =round(v_max_marcia1/3.6,1); % [m/s]
        vel_cambio_kmh_intermedia =round(v_max_marcia1,1); % [km/h]
    else
        
        %devo calcolarmi, se mi coviente, la velocità di cambio
        %campo nel quale vado a ricercare la v cambio è: (T_em_marcia2 < x < T_em_maxspeed_1) (n_trans_2 < x < 100 km/h)
        T_prova_iniz =floor(T_em_marcia2);
        T_prova_fin =ceil(T_em_maxspeed_1);
        
        v_prova_iniz =ceil(n_trans_2);
        
        
        if v_max_marcia1 > 100
            flag_finale =0; %flag che mi dice fino a quale velocita devo provare a trovare il cambio marcia
            v_prova_finale =100;
        else
            flag_finale =1;
            v_prova_finale =floor(v_max_marcia1);
        end
       
        
        %mi calcolo i rendimenti per ogni i-coppia con pot massima all'interno dell'area di cambio
        flag_velocita =0;
        
        %for i=T_prova_iniz:1:T_prova_fin
        for i=v_prova_iniz:1:v_prova_finale
            
            %T_i =i;
            v_i_ricerca_1 =(i/costante1_x);
            v_i_ricerca_2 =(i/costante2_x);
            
            Tw_mot_ti_i1 =(30*P_nom*1000)/(pi*v_i_ricerca_1);
            Tw_mot_ti_i2 =(30*P_nom*1000)/(pi*v_i_ricerca_2);
            
%             Tw_mot_ti_i1 =T_i/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
%             Tw_mot_ti_i2 =T_i/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento
            
%             n_max_Ti_i1 =(30*P_nom*1000)/(pi*Tw_mot_ti_i1);
%             n_max_Ti_i2 =(30*P_nom*1000)/(pi*Tw_mot_ti_i2);
            v_max_Ti_i1 =v_i_ricerca_1*(pi/30);
            v_max_Ti_i2 =v_i_ricerca_2*(pi/30);
         
            %CALCOLO RENDIMENTO PER MARCIA 1
            P_em_i1 =Tw_mot_ti_i1*v_max_Ti_i1; %potenza del motore nel punto i generico [W]

            parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
            parte_2 =kc*(Tw_mot_ti_i1^2)*(T_ref/T_em)^2;
            parte_3 =ki*v_max_Ti_i1*(n_ref/n_mot_rad_s);
            parte_4 =kw*(v_max_Ti_i1^3)*(n_ref/n_mot_rad_s)^3;
            P_loss_i1 =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]

            eta_ti_i1 =P_em_i1/(P_em_i1+P_loss_i1); %rendinento nel punto generico i [eta_i]
            
            %CALCOLO RENDIMENTO PER MARCIA 2
            P_em_i2 =Tw_mot_ti_i2*v_max_Ti_i2; %potenza del motore nel punto i generico [W]

            parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
            parte_2 =kc*(Tw_mot_ti_i2^2)*(T_ref/T_em)^2;
            parte_3 =ki*v_max_Ti_i2*(n_ref/n_mot_rad_s);
            parte_4 =kw*(v_max_Ti_i2^3)*(n_ref/n_mot_rad_s)^3;
            P_loss_i2 =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]

            eta_ti_i2 =P_em_i2/(P_em_i2+P_loss_i2); %rendinento nel punto generico i [eta_i]

            if eta_ti_i2 > eta_ti_i1 && flag_velocita ==0
                flag_velocita =1;
                
%                 vel_cambio_kmh_intermedia =n_max_Ti_i2*costante2_x;
%                 vel_cambio_ms_intermedia =round(vel_cambio_kmh_intermedia/3.6,1);  % [m/s]
                  vel_cambio_kmh_intermedia =i;
                  vel_cambio_ms_intermedia =i/3.6;
            end
        
        end %fine ciclo for
        
        %caso in cui la v max_1 < 100 e non ho trovato un cambio (cambio in seconda perche finisce la zona di lavoro della prima marcia)
        if flag_finale ==1 && flag_velocita ==0
           vel_cambio_ms_intermedia =v_max_marcia1/3.6;
           vel_cambio_kmh_intermedia =v_max_marcia1;
        end
      
        %caso in cui la v max_1 > 100 e non ho trovato un cambio (non ho cambio marcia, ma per funzionare l'algoritmo considero un cambio marcia a 100 km/h)
        if flag_finale ==0 && flag_velocita ==0
           vel_cambio_ms_intermedia =100/3.6;
           vel_cambio_kmh_intermedia =100;
        end
       
    end
    
    
    fun_1 = @(x) (m_v*delta)./(  ((T_em*marcia.prima*eta_pt)./rt) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    
    %fun_1_2 = @(x) (m_v*delta)./(  ((T_em_marcia1*v_climb/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    fun_1_2 = @(x) (m_v*delta)./(  ((T_em_marcia1*n_trans_1/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    
    %fun_2 = @(x) (m_v*delta)./(  ((T_em_maxspeed_2*v_max/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
    fun_2 = @(x) (m_v*delta)./(  ((T_em_marcia2*n_trans_2/3.6)./(rt.*x)) - F_attrito_50 - ( ((Cd*S_ev)/(21.15))*(x.^(2)) )  );
        
    Int_1 =integral( fun_1,0,n_trans_1/3.6 );
    Int_2 =integral( fun_1_2,n_trans_1/3.6,vel_cambio_ms_intermedia );
    Int_3 =integral( fun_2,vel_cambio_ms_intermedia,vel_kmh_finale );
        
    risposta =Int_1+Int_2+Int_3+(tempo_cambio*(vel_cambio_kmh_intermedia ~=100)); %per la parte di debug
    
end


fprintf ('\nIl tempo teorico che il veicolo impiega per passare da 0-100 km/h (con i_marcia-1: %.2f, i_marcia-2: %.2f) è circa di %.2f secondi\n\n', marcia.prima, marcia.seconda, risposta); %matrice_0_100(index,pedex) per la parte di debug


%%%%%%%%%%%%%%%
%STAMPO IL GRAFICO CHE MI DESCRIVE LA VELOCITA IN FUNZIONE DEL TEMPO

if n_trans_2 >= 100
   %siamo solo in prima
   grafico_tempo_velocita =zeros(2,12);
   vel_cambio_copp_pot = floor(n_trans_1/10);
   
   for i=10:10:vel_cambio_copp_pot*10
   grafico_tempo_velocita(1,i/10+1) =i;    
   grafico_tempo_velocita(2,i/10+1) =integral( fun_1,0,i/3.6 );
   end
   
   grafico_tempo_velocita(1,i/10+2) =floor(n_trans_1); 
   grafico_tempo_velocita(2,i/10+2) =integral( fun_1, 0, floor(n_trans_1)/3.6 );
   val_da_sommare_1 =grafico_tempo_velocita(2,i/10+2);
   
   for i=(vel_cambio_copp_pot+1)*10:10:110
   grafico_tempo_velocita(1,i/10+2) =i;    
   grafico_tempo_velocita(2,i/10+2) =val_da_sommare_1 +integral( fun_1_2, floor(n_trans_1)/3.6, i/3.6 );
   end 
   
else 
    
   if flag_finale ==0 && flag_velocita ==0
      %siamo sempre solo in prima
      grafico_tempo_velocita =zeros(2,12);
      vel_cambio_copp_pot = floor(n_trans_1/10);
   
      for i=10:10:vel_cambio_copp_pot*10
      grafico_tempo_velocita(1,i/10+1) =i;    
      grafico_tempo_velocita(2,i/10+1) =integral( fun_1,0,i/3.6 );
      end
   
      grafico_tempo_velocita(1,i/10+2) =floor(n_trans_1); 
      grafico_tempo_velocita(2,i/10+2) =integral( fun_1, 0, floor(n_trans_1)/3.6 );
      val_da_sommare_1 =grafico_tempo_velocita(2,i/10+2);
   
      for i=(vel_cambio_copp_pot+1)*10:10:110
      grafico_tempo_velocita(1,i/10+2) =i;    
      grafico_tempo_velocita(2,i/10+2) =val_da_sommare_1 +integral( fun_1_2, floor(n_trans_1)/3.6, i/3.6 );
      end 
      
   else 
      %caso in cui ho un cambio marcia in seconda
      grafico_tempo_velocita =zeros(2,15);
      
      vel_cambio_diviso_10 = floor(vel_cambio_kmh_intermedia/10);
      vel_cambio_copp_pot = floor(n_trans_1/10);
       
      for i=10:10:vel_cambio_copp_pot*10
      grafico_tempo_velocita(1,i/10+1) =i;    
      grafico_tempo_velocita(2,i/10+1) =integral( fun_1,0,i/3.6 );
      end
      
      grafico_tempo_velocita(1,i/10+2) =floor(n_trans_1);    
      grafico_tempo_velocita(2,i/10+2) =integral( fun_1, 0, floor(n_trans_1)/3.6 );
      val_da_sommare_1 =grafico_tempo_velocita(2,i/10+2);
      
      for i=(vel_cambio_copp_pot+1)*10:10:vel_cambio_diviso_10*10
      grafico_tempo_velocita(1,i/10+2) =i;    
      grafico_tempo_velocita(2,i/10+2) =val_da_sommare_1 +integral( fun_1_2, floor(n_trans_1)/3.6, i/3.6 );
      end 
      
      grafico_tempo_velocita(1,i/10+3) =floor(vel_cambio_kmh_intermedia);    
      grafico_tempo_velocita(2,i/10+3) =val_da_sommare_1 +integral( fun_1_2, n_trans_1/3.6, floor(vel_cambio_kmh_intermedia)/3.6 );
      val_da_sommare_2 =grafico_tempo_velocita(2,i/10+3);
      
      grafico_tempo_velocita(1,i/10+4) =floor(vel_cambio_kmh_intermedia);
      grafico_tempo_velocita(2,i/10+4) =val_da_sommare_2+tempo_cambio;
     
      for i=(vel_cambio_diviso_10+1)*10:10:110
      grafico_tempo_velocita(1,i/10+4) =i;    
      grafico_tempo_velocita(2,i/10+4) =val_da_sommare_2 +tempo_cambio +integral( fun_2,vel_cambio_kmh_intermedia/3.6,i/3.6 );
      end 
       
      
   end
      
end


figure
Grafico_velocita =plot(grafico_tempo_velocita(2,1:end-1),grafico_tempo_velocita(1,1:end-1),'r-');
xlabel('Time/s'), ylabel('Speed/km.h^-^1');
title('andamento velocità durante il tempo di accelerazione 0-100') 


%MI CALCOLO IL GRAFICO DELL'ACCELERAZIONE
stringa_accelerazioni =zeros(2,size(grafico_tempo_velocita,2)-1);

for i=1:(size(grafico_tempo_velocita,2)-1)

    stringa_accelerazioni(1,i) =grafico_tempo_velocita(1,i);
    stringa_accelerazioni(2,i) =(grafico_tempo_velocita(1,i+1)-grafico_tempo_velocita(1,i))/(3.6*(grafico_tempo_velocita(2,i+1)-grafico_tempo_velocita(2,i)));
    
end

%per stamparlo bene devo eliminare il valore di passaggio tra i due metodi
 stringa_accelerazioni_stampa =zeros(2,size(stringa_accelerazioni,2)-1);
 
 for i=1:(size(stringa_accelerazioni,2))

    if i ~= vel_cambio_copp_pot+2 && i<vel_cambio_copp_pot+2
    stringa_accelerazioni_stampa(1,i) =stringa_accelerazioni(1,i);
    stringa_accelerazioni_stampa(2,i) =stringa_accelerazioni(2,i);
    end
    
    if i ~= vel_cambio_copp_pot+2 && i>=vel_cambio_copp_pot+2
    stringa_accelerazioni_stampa(1,i-1) =stringa_accelerazioni(1,i);
    stringa_accelerazioni_stampa(2,i-1) =stringa_accelerazioni(2,i);
    end
    
end


figure
Grafico_accelerazioni_stampa =plot(stringa_accelerazioni_stampa(1,:),stringa_accelerazioni_stampa(2,:),'b-');
xlabel('Speed/km.h^-^1'), ylabel('Acceleration/m.s^-^2');
title('andamento accelerazione del veicolo')

