%% grafico rendimenti secondo: Electric Vehicle Technology - James Larminie, John Lowry

%prova manuale in cui cerco di rendere il codice james-lowry Generico
T_em =250; %[Nm]
n_mot =10000; %[rpm]
P_nom =75; %[kw]

T_em_maxspeed =(30*P_nom*1000)/(pi*n_mot);

%%Valori relativi ad un motore DC avente maggiore ponteza, maggiore velocità, SENZA spazzole
rad_s_i =linspace(1,1000);% velocità, Nota Bene: [rad/s] NON [rpm] 
T_em_i =linspace(1,250); % coppia, espressa in [Nm], da 0 a 40 Nm
% impostiamo i valori delle costanti di perdita del motore
kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

matrice_rendimenti =zeros ((T_em)+1,(n_mot/2.5)+1);  

%applico un primo ciclo for, in cui analizzo tutte le coppie da T=0 a T_em
for T_em_i=1:T_em
    
    
   if T_em_i <= T_em_maxspeed
      n_max_i =n_mot;
   else     
      n_max_i =(30*P_nom*1000)/(pi*T_em_i);
   end
   n_max_rad_i =n_max_i*(pi/30); %trasformo gli rpm in rad/s
    
   
   vel_Tem_ =(0:2.5:n_max_rad_i);
   eta_i =zeros(size(vel_Tem_)); %soluzione ogni T_em
   
   
     for i=1:size(vel_Tem_,2)
       
        Output_power =vel_Tem_(i)*T_em_i; % Momento*velocità =Potenza
        
        parte_1 =(T_em_i^2)*kc; % Perdita nel rame
        parte_2 =vel_Tem_(i)*ki; % Perdita nel ferro
        parte_3 =(vel_Tem_(i)^3)*kw; % coefficiente di perdita nell'aria
        Input_power =Output_power+parte_1+parte_2+parte_3+C;
        Z =Output_power/Input_power;
       
        eta_i(i) =Z; %rendinento nel punto generico i [eta_i]
        
     end
   
     
matrice_rendimenti(T_em_i+1,1:size(eta_i,2)) =eta_i(1:end);
    
end


% Output_power =(X.*Y); % Momento*velocità =Potenza
% parte_1 =(Y.^2)*kc; % Perdita nel rame
% parte_2 =X*ki; % Perdita nel ferro
% parte_3 =(X.^3)*kw; % coefficiente di perdita nell'aria
% Input_power =Output_power+parte_1+parte_2+parte_3+C;
% Z =Output_power./Input_power;