% programma ottimo SOC
clear
clc

%combinazioni tipiche di ingranaggi
%(8.5) riga 27
%(3.4) colonna 4

%inserimento dati manuale
rho_aria =1.225;
Cd =0.28;
S_ev =2.19;
f_volv =0.0083;
m_v =1645;
perc_peso= 0.55;
m_v_1 =m_v*perc_peso;
g =9.81;
phi_i =0;
phi= 14; %angolo di inclinazione massimo della strada (pendenza 25%)
v_climb= 70; %velocità in salita massima del veicolo espressa in [km/h] (44 mph)
delta =1.05;
rt =0.315;
eta_pt= 0.95; %efficienza di trasmissione assunta 95%

T_em =254;
P_nom= 80; %Potenza Nominale del motore [kW] (rated power)
v_max =205;
n_mot= 10000; %velocità massima raggiunta dal motore [rpm] (peak velocity)
n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s
selez2= 2;  %selezione che mi indica se vi è la presenza del rapporto di trasmissione del riduttore (2 non c'è)
i_0tr= 1; %valore del riduttore

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
P_nom_ref =75; %[kw]

kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore

% costante1_x =((2*pi)/60)*3.6*(rt/marcia.prima);
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);

SOC =0.9; %valore iniziale della batteria
delta_t =1; %intervallo in cui studio la variazione della batteria [sec]
Ud_k =300; %tensione batteria [V]
acceleraz_max =2.8571; %accelerazione massima raggiunta durante la prova NEDC
C_batt= 70; %capacità batteria espressa in Ampere ora [A h]

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%calcolo della T_em_maxspeed
n_trans =(30*P_nom*1000)./(pi*T_em);
x1 =linspace(0,n_trans,10000);
T_funz_Tmax =T_em+x1*0;
x2 =linspace(n_trans,n_mot,10000);
T_funz =(30*P_nom*1000)./(pi*x2);

%grafico momento torcente motore
figure
Grafico_1 =plot(x1,T_funz_Tmax,'b-',x2,T_funz,'b-');
xlabel('Speed/rpm'), ylabel('Torque/N.m'); 
title(['Grafico coppia/velocita motore elettrico con Pnom =' num2str(P_nom) 'Nm'])

%calcolo il valore della coppia alla massima velocita del motore
T_em_maxspeed =(30*P_nom*1000)/(pi*n_mot);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%calcolo le forze che entrano in gioco nella marcia-1
F_aerodinamica_1 =0.5*rho_aria*Cd*S_ev*((v_climb/3.6)^2);
F_attrito_1 =f_volv*m_v_1*g*cosd(phi);
F_climbing_1 =m_v_1*g*sind(phi);

%calcolo rapporto min marcia 1 (il minimo rapporto che serve per far andare il veicolo in salita)
i_1min =(rt*(F_attrito_1+F_climbing_1+F_aerodinamica_1))/(eta_pt*T_em);

%calcolo le forze che entrano in gioco nella marcia-2
F_aerodinamica_2 =0.5*rho_aria*Cd*S_ev*((v_max*(1000/3600))^2);
F_attrito_2 =f_volv*m_v_1*g;
%F_climbing qua è pari a zero perche si ipotizza che la massima velocita si raggiunge in piano

%calcolo rapporto max marcia 2 (il massimo rapporto raggiungibile con la velocita ipotizzata)
%i_2max deve essere MINORE di i_2max_maxspeed perchè: (i_2max < i_2max_maxspeed)
%ho raggiunto la max velocità imposta con la max velocità del motore, posso raggiungere la stessa velcoita massima con i_2max PIU PICCOLI diminuendo contestualmente la vel del motore
i_2max_maxspeed =((pi/30)*n_mot*rt)/(v_max*(1000/3600));
%i_2max deve essere MAGGIORE di i_2max_maxtorque perchè: (i_2max > i_2max_maxtorque)
%mi trovo alla velocita max del motore, per raggiungere la Vmax del veicolo imposta devo avere ALMENO questo rapporto di trasmissione
i_2max_maxtorque =(rt*(F_attrito_2+F_aerodinamica_2))/(eta_pt*T_em_maxspeed);

%controllo valore marcia 2
if i_2max_maxspeed > i_2max_maxtorque
    i_2max= i_2max_maxspeed;
    %la velocità massima raggiungibile ipotizzata del veicolo è consona alla taglia del motore preso in considerazione
    %calcolo la velocità limite massima raggiungibile dal veicolo che può sopportare la taglia del motore in esame
    v_max_i2_accettabile =((pi/30)*n_mot*rt)/(i_2max_maxtorque*(1000/3600));
else
    %condizione NON ACCETABILE:
    fprintf ('\nATTENZIONE!!! (1) \nPer le condizioni di lavoro ipotizzare (Vmax) il motore scelto ha dei valori di taglia troppo piccoli! \nInfatti ottengo un assurdo sulla condizione di esistenza del rapporto di trasmissione max della marcia-2:\n i2_max < %.2f & i2_max > %.2f', i_2max_maxspeed, i_2max_maxtorque);
    %o si cambia la Vmax del veiolo: calcolo la velocità massima raggiungibile dal veicolo con il motore in esame
    v_max_i2_accettabile =((pi/30)*n_mot*rt)/(i_2max_maxtorque*(1000/3600));
    %o si cambia la taglia del motore: tengo costanti le ipotesi di lavoro e calcolo la taglia del motore che mi serve
    %aumento il numero di giri max a 10000 aumentando contestualmnte la potenza nominale
    
    i_2_mt =i_2max_maxtorque;
    i_2_mv =i_2max_maxspeed;
    P_nom_i =P_nom;
    n_mot_i =n_mot;
    while i_2_mv < i_2_mt
          if n_mot_i < 10000
             n_mot_i =n_mot_i+50;    
          end
          P_nom_i =P_nom_i+2;
          T_em_mv_i =(30*P_nom_i*1000)/(pi*n_mot_i); 
          i_2_mv =((pi/30)*n_mot_i*rt)/(v_max*(1000/3600));
          i_2_mt =(rt*(F_attrito_2+F_aerodinamica_2))/(eta_pt*T_em_mv_i);      
    end 
    
    i_2max =i_2_mv;
    P_em_minima =P_nom_i;
    fprintf ('\n\nSe si considera valido il motore in esame, la velocità massima raggiungibile da tale veicolo deve essere pari a: %.2f [km/h]\n', v_max_i2_accettabile);
    fprintf ('Se si considerano valide le condizioni di lavoro ipotizzare, il motore deve avere una potenza nominale pari a: %.2f [N*m]\n', P_em_minima);
end

%Calcolo gli estremi secondo Lechner (va da 2,2 a 3,4)
i_1max =i_2max*3.4;
i_2min =i_1min/3.4;

%riassunto dati ottenuti

if selez2 == 1
    i_1 =struct('min',(ceil(i_1min*10))/10, 'max',(floor(i_1max*10))/10);
    fprintf ('\n\nIntervallo in cui trovare il rapporto di trasmissione marcia-1 ottimale è (tenendo conto che i_0 (riduttore)=%.2f):\n', i_0tr);
    fprintf ('    min: %.3f (%.2f) [con rid: %.2f]\n    max: %.3f (%.2f) [con rid: %.2f]\n\n',i_1min,i_1.min,i_1.min/i_0tr,i_1max,i_1.max,i_1.max/i_0tr);
    
    i_2 =struct('min',(ceil(i_2min*10))/10, 'max',(floor(i_2max*10))/10);
    fprintf ('Intervallo in cui trovare il rapporto di trasmissione marcia-2 ottimale è (tenendo conto che i_0 (riduttore)=%.2f):\n', i_0tr);
    fprintf ('    min: %.3f (%.2f) [con rid: %.2f]\n    max: %.3f (%.2f) [con rid: %.2f]\n\n',i_2min,i_2.min,(i_2.min/i_0tr),i_2max,i_2.max,(i_2.max/i_0tr));
else 
    i_1 =struct('min',(ceil(i_1min*10))/10, 'max',(floor(i_1max*10))/10);
    fprintf ('\n\nIntervallo in cui trovare il rapporto di trasmissione totale marcia-1 (riduttore + marcia 1) ottimale è:\n');
    fprintf ('    min: %.3f (%.2f)\n    max: %.3f (%.2f)\n\n',i_1min,i_1.min,i_1max,i_1.max);
    
    i_2 =struct('min',(ceil(i_2min*10))/10, 'max',(floor(i_2max*10))/10);
    fprintf ('Intervallo in cui trovare il rapporto di trasmissione totale marcia-2 (riduttore + marcia 2) ottimale è:\n');
    fprintf ('    min: %.3f (%.2f)\n    max: %.3f (%.2f)\n\n',i_2min,i_2.min,i_2max,i_2.max);
    
    i_0tr =1;
    
end

%verifica validità dati ottenuti
if i_1.min > i_1.max || i_2.min > i_2.max
    fprintf ('\nATTENZIONE!!! (2) \nTaglia motore troppo piccola per le condizioni di lavoro individuate in fase di progetto. \n(Ottengo un assurdo negli estremi degli intervalli di esistenza dei rapporti di trasmissione)\n');
    %calcolo il valore di coppia minima che permette di ottenere le condizioni di lavoro ipotizzate.
    %dall espressione di i_2max mi ricavo i_1max. successivamente considero i_1min=i_1max per ottenere 
    %la minima coppia che non mi genera un assurdo negli intervalli di esistenza dei rapporti di trasmissione
    i_1_min_prova =i_1.max;
    T_em_minima =(rt*(F_attrito_1+F_climbing_1+F_aerodinamica_1))/(i_1_min_prova*eta_pt);
    fprintf ('\nPer le condizioni di lavoro ipotizzare il motore scelto deve avere un valore minimo di coppia nominale pari a: %f [N*m]\n(La coppia nominale ipotizzata è di: %.2f[N*m])\n', T_em_minima, T_em);
else
    if i_1.max > 40
        fprintf ('\nATTENZIONE!!! (3) \nPer le condizioni di lavoro ipotizzare il motore scelto ha dei valori di taglia troppo piccoli. ottengo un i_1.max troppo alto: %.2f\n', i_1.max);
    else 
        fprintf ('\ncaratteristiche del motore compatibili con le condizioni di lavoro ipotizzate.\n');
    end

end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




% F_aerodinamica_i =0.5*rho_aria*Cd*S_ev*((v/3.6)^2);
%F_aerodinamica_i =(0.5*rho_aria*Cd*S_ev*((vel_veicolo(t)/3.6)^2));
% F_attrito_i =f_volv*m_v_1*g*cosd(phi_i);
% F_climbing_i =m_v_1*g*sind(phi_i);
% F_accelerazione =((v-v_precedente)>0)*(m_v*delta*((v-v_precedente)/3.6));
%F_accelerazione =(((vel_veicolo(t)-vel_veicolo(t-1))>0)*(m_v*delta*((vel_veicolo(t)-vel_veicolo(t-1))/3.6)));

% F_req_k =F_aerodinamica_i+F_attrito_i+F_climbing_i+F_accelerazione;
% Tw_req_k =F_req_k*rt; %[Nm]

% v=120;
% v_precedente=120;
% F_aerodinamica_i =0.5*rho_aria*Cd*S_ev*((v/3.6)^2);
F_attrito_i =f_volv*m_v_1*g*cosd(phi_i);
F_climbing_i =m_v_1*g*sind(phi_i);
% F_accelerazione =((v-v_precedente)>0)*(m_v*delta*((v-v_precedente)/3.6));

            

vel_istanti =zeros(1,1179);
for i=1:1179

    vel_istanti(1,i) =vel_veicolo(i);

end

F_accelerazione =m_v*delta*((vel_istanti(1,2:end)-vel_istanti(1,1:end-1))/3.6);
                       
Tw_req_k_vett_pm =  ((0.5*rho_aria*Cd*S_ev*((vel_istanti(1,2:end)./3.6).^2))+F_attrito_i+F_climbing_i+F_accelerazione)*rt; 
                          
Tw_req_k_vett = (Tw_req_k_vett_pm >=0).*Tw_req_k_vett_pm + ((Tw_req_k_vett_pm)<0).*(Tw_req_k_vett_pm.*(-1));
            
 

% eta_1 =P_em_i/(P_em_i+P_loss_i);
% eta_2 =P_em_i/(P_em_i+P_loss_i);
% 
% P_em_i =Tw_req_mot_kmh1*vel_Tem_cambio_km_i;
% Tw_req_mot_kmh1 =Tw_req_50/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
% Tw_req_mot_kmh2 =Tw_req_50/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento
% vel_Tem_cambio_km_1 =(vel_Tem_cambio(i)/costante1_x)*(pi/30);
% vel_Tem_cambio_km_2 =(vel_Tem_cambio(i)/costante2_x)*(pi/30);
% costante1_x =(((2*pi)/60)*3.6*(rt/marcia.prima));
% costante2_x =((2*pi)/60)*3.6*(rt/marcia.seconda);
% 
% parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
% parte_2 =kc*(coppia_mev_marcia1.uno^2)*(T_ref/T_em)^2;
% parte_3 =ki*vel_Tem_cambio_km_i*(n_ref/n_mot_rad_s);
% parte_4 =kw*(vel_Tem_cambio_km_i^3)*(n_ref/n_mot_rad_s)^3;
% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C);            



% P_em_i =        ((Tw_req_k(t)./(T_em*x(1)))*T_em)*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30));



parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
% parte_2 =kc*(((Tw_req_k(t)./(T_em*x(1)))*T_em).^2)*(T_ref/T_em)^2;
% parte_3 =ki*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30))*(n_ref/n_mot_rad_s);
% parte_4 =kw*(((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30)).^3)*(n_ref/n_mot_rad_s)^3;
% P_loss_i =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]


% P_loss_i =        parte_1*((kc*(((Tw_req_k(t)./(T_em*x(1)))*T_em).^2)*(T_ref/T_em)^2)+...
%                   (ki*((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30))*(n_ref/n_mot_rad_s))+...
%                   (kw*(((vel_veicolo(t)./(((2*pi)/60)*3.6*(rt/x(1))))*(pi/30)).^3)*(n_ref/n_mot_rad_s)^3)+C);

              
              
P_em_i_1_vett =@(x) (Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_1_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);
 
fun_eta_1_vett =@(x) ((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));
 

P_em_i_2_vett =@(x) (Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));

P_loss_2_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_2_vett =@(x) ((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                     (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                     (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                     (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                     (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));                 
                 
   
                 
% eta_max =@(t,x) max((fun_eta_1(t,x)),(fun_eta_2(t,x)));


fun_eta_1_meno_2_vett =@(x) (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(1).*i_0tr*eta_pt)).*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(1)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(1)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))))-...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                            (((Tw_req_k_vett./(x(2).*i_0tr*eta_pt)).*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                            (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*x(2)))*T_em).^2).*(T_ref/T_em)^2))+...
                            (ki.*(((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                            (kw.*((((30*x(2)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C))));
                       

scelta_marcia_vett =@(x) (fun_eta_1_meno_2_vett(x)>=0)*x(1) + (fun_eta_1_meno_2_vett(x)<0)*x(2);   

                     
                     
% P_m_k =(T_m_k*omega_m_k)/(9550*eta_i_k);

% T_m_k =((Tw_req_k(t))./(scelta_marcia(t,x)*i_0tr*eta_pt));
% Tw_req_k_1 =(Tw_req_k(t)./(T_em*x(1)))*T_em;
% T_m_k =((Tw_req_k(t)./(T_em*(scelta_marcia(t,x))))*T_em)./(scelta_marcia(t,x)*i_0tr*eta_pt);
% T_m_k =Tw_req_k/(marcia_i*i_0tr*eta_pt);
% Tw_req_k =F_req_k*rt;
            
% omega_m_k =(30*marcia_i*i_0tr*(v/3.6))/(pi*rt);
% omega_m_k =(30*i_0tr*scelta_marcia(t,x).*(vel_veicolo(t)/3.6))/(pi*rt);
% omega_m_k_rads =omega_m_k*(pi/30);
% omega_m_k_rads =((30*i_0tr*scelta_marcia(t,x).*(vel_veicolo(t)/3.6))/(pi*rt))*(pi/30);
% eta_i_k =P_em_i/(P_em_i+P_loss_i);

                
P_gen_vett =@(x) (Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x).*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30));
 
P_loss_vett =@(x)  parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C);

fun_eta_vett =@(x) ((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))./...
                   (((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)))+...
                   (parte_1.*(((kc*(((Tw_req_k_vett./(T_em*scelta_marcia_vett(x)))*T_em).^2).*(T_ref/T_em)^2))+...
                   (ki.*(((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).*(n_ref/n_mot_rad_s))+...
                   (kw.*((((30*scelta_marcia_vett(x)*i_0tr.*(vel_istanti(1:end-1)./3.6))./(pi*rt))*(pi/30)).^3).*(n_ref/n_mot_rad_s)^3)+C)));
 

                
% fun_P_m_k_vett([8.5,3.4])                
% +(vel_veicolo(t) == 0)



% P_m_k =(T_m_k*omega_m_k)/(9550*eta_i_k)
%((fun_eta_vett(x) == 0)+fun_eta_vett(x))
              
              
% fun_P_m_k_vett =@(x) (F_accelerazione >=  0).*((fun_eta_vett(x)~= 0).*(((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*...
%                                                                       ((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./(9550*((fun_eta_vett(x) == 0)+fun_eta_vett(x))))...
%                                              +(fun_eta_vett(x)== 0).*((parte_1*C)/1000))...
%                     +(F_accelerazione < 0).*((fun_eta_vett(x)~= 0).*((((Tw_req_k_vett_pm./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*...
%                                                                      ((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./(9550)).*fun_eta_vett(x))...
%                                              +(fun_eta_vett(x)== 0).*((parte_1*C)/1000));
                                         
%mi esce NaN, spacchetto per capire cosa non funziona
fun_P_m_k_vett_1 =@(x) (F_accelerazione >=  0).*((fun_eta_vett(x)~= 0).*(((Tw_req_k_vett./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*...
                                                                        ((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./(9550*((fun_eta_vett(x) == 0)+fun_eta_vett(x))))...
                                               +(fun_eta_vett(x)== 0).*((parte_1*C)/1000));

fun_P_m_k_vett_2 =@(x) (F_accelerazione < 0).*((fun_eta_vett(x)~= 0).*((((Tw_req_k_vett_pm./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*...
                                                                      ((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./(9550)).*fun_eta_vett(x))...
                                               +(fun_eta_vett(x)== 0).*((parte_1*C)/1000));
                                           
fun_P_m_k_vett =@(x) fun_P_m_k_vett_1(x) +fun_P_m_k_vett_2(x);                                      
                                           
                
% (((Tw_req_k_vett_pm./(scelta_marcia_vett(x).*i_0tr*eta_pt)).*((30*i_0tr*scelta_marcia_vett(x).*(vel_istanti(1,2:end)/3.6))/(pi*rt)))./(9550)).*fun_eta_vett(x)
             
% ((fun_eta_i_k(t,x) == 0)+fun_eta_i_k(t,x)) %per evitare di avere al denominatore uno zero nel caso di v=0;            


% Id_k =P_m_k*1000/Ud_k; %ampere
fun_Id_k_vett =@(x) fun_P_m_k_vett(x).*1000/Ud_k; %ampere

 
% delta_SOC =(Id_k/(3600*C_batt))*delta_t;
fun_SOC_spesa_vett =@(x) ((fun_P_m_k_vett(x).*1000/Ud_k)./(3600*C_batt))*delta_t;

% SOC =SOC-delta_SOC;  
fun_obiettivo =@(x) sum(fun_SOC_spesa_vett(x));



% x=5.9; %[marcia_1]
% y=2.034; %[marcia_2]  
% % % [8.5,3.4],[16.8,5.25]
% prova_1 =fun_P_m_k_vett_1([8.5,3.4]);
% prova_2 =fun_P_m_k_vett_2([8.5,3.4]);
% prova_3 =fun_P_m_k_vett([8.5,3.4]);
% 
% risposta =fun_obiettivo([x,y]);  
% fprintf('\nil valore SOC residuo (con marica1: %.2f e marcia2: %.2f) è pari a: %.4f\n',x,y,risposta)


x0 =[i_1.min, i_2.min];
A =[];
B =[];
Aeq =[];
Beq =[];
lb =[i_1.min, ceil(i_1.min/3.4*10)/10];
ub =[floor(i_2.max*3.4*10)/10, i_2.max];

nonlincon =@nlcon;

marce_SOC_migliore =fmincon(fun_obiettivo,x0,A,B,Aeq,Beq,lb,ub,nonlincon);
SOC_residuo = SOC-fun_obiettivo([marce_SOC_migliore(1),marce_SOC_migliore(2)]);
fprintf('\nla combinazione di ingranaggi che ottimizza il valore SOC è:\nmarcia-1: %.2f\nmarcia-2: %.2f\n',marce_SOC_migliore(1),marce_SOC_migliore(2)) 
fprintf('\nil valore SOC è: %.4f\n',SOC_residuo) 



