function [v_km, v_ms] = vel_cambio(i1, i2, P_nom, T_em, n_mot, rt)


costante1_x =((2*pi)/60)*3.6*(rt/i1);
costante2_x =((2*pi)/60)*3.6*(rt/i2);

v_max_marcia1 =n_mot*costante1_x;
% v_max_marcia2 =n_mot*costante2_x;

% T_em_marcia1 =T_em*i1;
% T_em_marcia2 =T_em*i2;

% T_em_maxspeed =(30*P_nom*1000)/(pi*n_mot);
% T_em_maxspeed_1 =T_em_maxspeed*i1;
% T_em_maxspeed_2 =T_em_maxspeed*i2;

n_trans =(30*P_nom*1000)./(pi*T_em);
%n_trans_1 =n_trans*costante1_x;
n_trans_2 =n_trans*costante2_x;

n_mot_rad_s =n_mot*(pi/30); %trasformo n_mot da rpm a rad/s

T_ref =250; %[Nm]
n_ref =10000*(pi/30); %[rad/s]
kc =0.2; % Perdita nel rame
ki =0.008; % Perdita nel ferro
kw =0.00001; % coefficiente di perdita nell'aria
C =400; % perdita costante nel motore


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if n_trans_2 >= 100
    
   v_km =100;
   v_ms =v_km/3.6;

else
    
   if n_trans_2 >= v_max_marcia1
      %caso particolare
      v_km =round(v_max_marcia1,1); % [km/h]
      v_ms =round(v_max_marcia1/3.6,1); % [m/s]
   else
        
      v_prova_iniz =ceil(n_trans_2);


      if v_max_marcia1 > 100
         flag_finale =0; %flag che mi dice fino a quale velocita devo provare a trovare il cambio marcia
         v_prova_finale =100;
      else
         flag_finale =1;
         v_prova_finale =floor(v_max_marcia1);
      end


        %mi calcolo i rendimenti per ogni i-coppia con pot massima all'interno dell'area di cambio
        flag_velocita =0;
        
        %for i=T_prova_iniz:1:T_prova_fin
        for i=v_prova_iniz:1:v_prova_finale
            
            %T_i =i;
            v_i_ricerca_1 =(i/costante1_x);
            v_i_ricerca_2 =(i/costante2_x);
            
            Tw_mot_ti_i1 =(30*P_nom*1000)/(pi*v_i_ricerca_1);
            Tw_mot_ti_i2 =(30*P_nom*1000)/(pi*v_i_ricerca_2);
            
%             Tw_mot_ti_i1 =T_i/(eta_pt*marcia.prima*i_0tr); %coppia della marcia-1 riportata sul grafico motore per calcolo rendimento
%             Tw_mot_ti_i2 =T_i/(eta_pt*marcia.seconda*i_0tr); %coppia della marcia-2 riportata sul grafico motore per calcolo rendimento
            
%             n_max_Ti_i1 =(30*P_nom*1000)/(pi*Tw_mot_ti_i1);
%             n_max_Ti_i2 =(30*P_nom*1000)/(pi*Tw_mot_ti_i2);
            v_max_Ti_i1 =v_i_ricerca_1*(pi/30);
            v_max_Ti_i2 =v_i_ricerca_2*(pi/30);
         
            %CALCOLO RENDIMENTO PER MARCIA 1
            P_em_i1 =Tw_mot_ti_i1*v_max_Ti_i1; %potenza del motore nel punto i generico [W]

            parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
            parte_2 =kc*(Tw_mot_ti_i1^2)*(T_ref/T_em)^2;
            parte_3 =ki*v_max_Ti_i1*(n_ref/n_mot_rad_s);
            parte_4 =kw*(v_max_Ti_i1^3)*(n_ref/n_mot_rad_s)^3;
            P_loss_i1 =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]

            eta_ti_i1 =P_em_i1/(P_em_i1+P_loss_i1); %rendinento nel punto generico i [eta_i]
            
            %CALCOLO RENDIMENTO PER MARCIA 2
            P_em_i2 =Tw_mot_ti_i2*v_max_Ti_i2; %potenza del motore nel punto i generico [W]

            parte_1 =(T_em*n_mot_rad_s)/(T_ref*n_ref);
            parte_2 =kc*(Tw_mot_ti_i2^2)*(T_ref/T_em)^2;
            parte_3 =ki*v_max_Ti_i2*(n_ref/n_mot_rad_s);
            parte_4 =kw*(v_max_Ti_i2^3)*(n_ref/n_mot_rad_s)^3;
            P_loss_i2 =parte_1*(parte_2+parte_3+parte_4+C); %potenza dissipata nel punto generico [W]

            eta_ti_i2 =P_em_i2/(P_em_i2+P_loss_i2); %rendinento nel punto generico i [eta_i]

            if eta_ti_i2 > eta_ti_i1 && flag_velocita ==0
                flag_velocita =1;
                
%                 vel_cambio_kmh_intermedia =n_max_Ti_i2*costante2_x;
%                 vel_cambio_ms_intermedia =round(vel_cambio_kmh_intermedia/3.6,1);  % [m/s]
                  v_km =i;
                  v_ms =i/3.6;
            end
        
        end %fine ciclo for
        
        %caso in cui la v max < 100 e non ho trovato un cambio (cambio in seconda perche finisce la zona di lavoro della prima marcia)
        if flag_finale ==1 && flag_velocita ==0
           v_km =v_max_marcia1; 
           v_ms =v_max_marcia1/3.6;
        end
      
        %caso in cui la v max > 100 e non ho trovato un cambio (non ho cambio marcia, ma per funzionare l'algoritmo considero un cambio marcia a 100 km/h)
        if flag_finale ==0 && flag_velocita ==0
           v_km =100;
           v_ms =100/3.6;
        end
   end
       

end